set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists autoaufbewahrung_au//
create trigger autoaufbewahrung_au after update on autoaufbewahrung
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID, userID, username, action,
     server, section, teststep, details, unit, newvalues)
  select NEW.verfahrenID, NEW.accessID, 'autoaufbewahrung', NEW.ID,
    coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'update',
    showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
    showreg(NEW.teststep, NEW.teststep_v), showreg(NEW.details, NEW.details_v),
    showreg(NEW.einheit, NEW.einheit_v),
    concat('days=', NEW.mindesttage, '\nremark=', REPLACE(REPLACE(NEW.remark, '\\', '\\\\'), '\n', '\\n'))
  from dual
  where NEW.server != OLD.server OR NEW.server_v != OLD.server_v
    OR NEW.section != OLD.section OR NEW.section_v != OLD.section_v
    OR NEW.teststep != OLD.teststep OR NEW.teststep_v != OLD.teststep_v
    OR NEW.details != OLD.details OR NEW.details_v != OLD.details_v
    OR NEW.einheit != OLD.einheit OR NEW.einheit_v != OLD.einheit_v
    OR NEW.mindesttage != OLD.mindesttage OR NEW.remark != OLD.remark
    OR NEW.accessID != OLD.accessID;
end//


drop trigger if exists autoaufbewahrung_ai//
create trigger autoaufbewahrung_ai after insert on autoaufbewahrung
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID, userID, username, action,
     server, section, teststep, details, unit, newvalues)
  values
    (NEW.verfahrenID, NEW.accessID, 'autoaufbewahrung', NEW.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'insert',
     showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
     showreg(NEW.teststep, NEW.teststep_v), showreg(NEW.details, NEW.details_v),
     showreg(NEW.einheit, NEW.einheit_v),
     concat('days=', NEW.mindesttage, '\nremark=', REPLACE(REPLACE(NEW.remark, '\\', '\\\\'), '\n', '\\n')));
end//


drop trigger if exists autoaufbewahrung_bd//
create trigger autoaufbewahrung_bd before delete on autoaufbewahrung
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID, userID, username, action,
     server, section, teststep, details, unit, newvalues)
  values
    (OLD.verfahrenID, OLD.accessID, 'autoaufbewahrung', OLD.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'delete',
     showreg(OLD.server, OLD.server_v), showreg(OLD.section, OLD.section_v),
     showreg(OLD.teststep, OLD.teststep_v), showreg(OLD.details, OLD.details_v),
     showreg(OLD.einheit, OLD.einheit_v),
     coalesce(if(OLD.remark = @rettimeremark, '', concat('remark=', REPLACE(REPLACE(@rettimeremark, '\\', '\\\\'), '\n', '\\n'))),''));
end//

delimiter ;
