set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists autokombilimits_au//
create trigger autokombilimits_au after update on autokombilimits
  for each row
begin
  insert into changeprot
   (domainID, accessID, changedtable, tableID,
    userID, username, action, classes, server, section, teststep, newvalues)
  select
     verfahrenID, accessID, 'autokombilimits', ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'update',
     showreg(classes, classes_v), showreg(server, server_v), showreg(section, section_v),
     showreg(teststep, teststep_v),
     concat('expression=', expression, '\nrelation=', relation, '\ninfolevel=',
            infolevel, '\nwarnlevel=', warnlevel, '\nerrorlevel=', errorlevel,
            '\nnotifymode=', notifymode, '\nmessage=', REPLACE(REPLACE(meldung, '\\', '\\\\'), '\n', '\\n'),
            '\ndestination1=', notifdestname(meldungszielID),
            '\ndestination2=', notifdestname(meldungsziel2ID), '\nremark=',
            REPLACE(REPLACE(bemerkungen, '\\', '\\\\'), '\n', '\\n'), '\nactive=', aktiv)
  from autokombilimits
  where autokombilimits.ID = NEW.ID and NEW.TS = autokombilimits.TS;
end//


drop trigger if exists autokombilimits_ai//
create trigger autokombilimits_ai after insert on autokombilimits
  for each row
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID,
     userID, username, action, classes, server, section, teststep, newvalues)
  values
    (NEW.verfahrenID, NEW.accessID, 'autokombilimits', NEW.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'insert',
     showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
     showreg(NEW.teststep, NEW.teststep_v),
     concat('expression=', NEW.expression, '\nrelation=', NEW.relation, '\ninfolevel=',
            NEW.infolevel, '\nwarnlevel=', NEW.warnlevel, '\nerrorlevel=', NEW.errorlevel,
            '\nnotifymode=', NEW.notifymode, '\nmessage=', REPLACE(REPLACE(NEW.meldung, '\\', '\\\\'), '\n', '\\n'),
            '\ndestination1=', notifdestname(NEW.meldungszielID),
            '\ndestination2=', notifdestname(NEW.meldungsziel2ID), '\nremark=',
            REPLACE(REPLACE(NEW.bemerkungen, '\\', '\\\\'), '\n', '\\n'), '\nactive=', NEW.aktiv));
end//


drop trigger if exists autokombilimits_bd//
create trigger autokombilimits_bd before delete on autokombilimits
  for each row
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID,
     userID, username, action, classes, server, section, teststep, newvalues)
  values
    (OLD.verfahrenID, OLD.accessID, 'autokombilimits', OLD.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'delete',
     showreg(OLD.classes, OLD.classes_v), showreg(OLD.server, OLD.server_v), showreg(OLD.section, OLD.section_v),
     showreg(OLD.teststep, OLD.teststep_v),
     coalesce(if(OLD.bemerkungen = @combilimitsremark, '', concat('remark=', REPLACE(REPLACE(@combilimitsremark, '\\', '\\\\'), '\n', '\\n'))),''));
end//

delimiter ;
