-- cleanbwerte.sql
--
-- procedure cleanbwerte()
-- 
-- remove old entries in table bwerte

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS cleanbwerte//
create procedure cleanbwerte()
  deterministic
  sql security invoker
  begin
    declare i, z, dtn integer;
    declare td date;
    declare selcur cursor for select ID, testdatum,
        (select count(*) from difftos where difftos.ID = wi.ID) as ndt
      from wi
      where wtab = 'bwerte' order by ID;
    declare continue handler for not found set z = 1;

    set z = 0;
    open selcur;
    repeat
      fetch selcur into i, td, dtn;
      if z != 1 then
        if dtn > 0 then
          delete bwerte from bwerte
            left join difftos on difftos.ID = werteindizesID and difftos.dt = datum
            where werteindizesID = i and datum < td and difftos.ID is NULL;
        else
          delete from bwerte where werteindizesID=i and datum < td;
        end if;
      end if;
    until z = 1 end repeat;
    close selcur;
    optimize table bwerte;

    create temporary table ddids
      ( primary key (ID) )
      select daten.ID from daten left join bwerte on daten.ID=datenID
      where datenID is NULL;
    delete daten from daten, ddids where daten.ID=ddids.ID;
    drop temporary table ddids;
  end//

GRANT EXECUTE on PROCEDURE cleanbwerte to loggingadmin@'localhost'//
