-- cleanccdetails.sql
--
-- procedure cleanccdetails()
-- 
-- remove compressed combidetails with deleted details

delimiter //

DROP procedure IF EXISTS cleanccdetails//
create procedure cleanccdetails()
  deterministic
  sql security invoker
 begin

  declare z, e, slen, d, cdid, si, ei, ti, aid, fdwid, autoflag integer unsigned;
  declare q, cnstvars, uwids, fkt varchar(3000);
  declare ctype enum('num','str','dat','blob');
  declare cccurids cursor for
    select ID, usedwIDs from ccdetails where usedwIDs != '';
  declare ccdetcur cursor for
    select ccdetails.ID, serverID, sectionID, teststepID, accessID, formel,
      domautoID != groupautoID as af
    from ccdetails
    left join loggingtmp.clu using(ID)
    left join loggingtmp.lwids on lwids.ID = clu.usedlwID
    where formelsql != '' and lwids.ID is NULL;
  declare continue handler for not found set z = 1;

  create temporary table ssta
    (primary key(serverID, sectionID, teststepID, accessID))
    select serverID, sectionID, teststepID, accessID
    from lwerteindizes
    group by serverID, sectionID, teststepID, accessID;

  delete ccdetails
    from ccdetails
    left join ssta using(serverID, sectionID, teststepID, accessID)
    where ssta.serverID is NULL;

  drop temporary table ssta;

  create temporary table loggingtmp.lwids (primary key(ID))
    select ID from lwerteindizes;

  create temporary table loggingtmp.clu (
      ID integer unsigned not null,
      usedlwID integer unsigned not null,
      primary key(ID, usedlwID));

  open cccurids;
  set z = 0;
  fetch cccurids into cdid, uwids;
  while z != 1 do
    set e = 1;
    set slen = char_length(uwids);
    while e <= slen do
      set d = locate(',', uwids, e);
      if d > 0 then
        insert into loggingtmp.clu (ID, usedlwID) values (cdid, substring(uwids, e, d-e));
        set e = d + 1;
      else
        insert into loggingtmp.clu (ID, usedlwID) values (cdid, substring(uwids, e));
        set e = slen + 1;
      end if;
    end while;
    fetch cccurids into cdid, uwids;
  end while;
  close cccurids;

  set z = 0;
  open ccdetcur;
  fetch ccdetcur into cdid, si, ei, ti, aid, fkt, autoflag;
  while z != 1 do
    call convert_ccombi(si, ei, ti, aid, fkt, 'b', ',datum', q, fdwid, ctype, cnstvars, uwids);
    if q = '' then
      if autoflag then
        delete from ccdetails where ID = cdid;
      else
        update ccdetails set
            formelsql = '', firstdetwiID = 0, usedwIDs = ''
          where ID = cdid;
      end if;
    else
      update ccdetails set
          formelsql = q, firstdetwiID = fdwid, usedwIDs = trim(leading ',' from uwids)
        where ID = cdid;
    end if;
    fetch ccdetcur into cdid, si, ei, ti, aid, fkt, autoflag;
  end while;
  close ccdetcur;

  drop temporary table loggingtmp.lwids, loggingtmp.clu;

end //

GRANT EXECUTE on PROCEDURE cleanccdetails to loggingadmin@'localhost'//
