-- cleancclimits.sql
--
-- procedure cleancclimits()
-- 
-- remove compressed combilimits with deleted details

delimiter //

DROP procedure IF EXISTS cleancclimits//
create procedure cleancclimits()
  deterministic
  sql security invoker
 begin

  declare z, e, d, slen, clid, si, ei, ti, aid, fdwid, autoflag integer unsigned;
  declare q, cnstvars, uwids, fkt varchar(3000);
  declare ctype enum('num','str','dat','blob');
  declare cclimcurids cursor for
    select ID, usedwIDs from cclimits where usedwIDs != '';
  declare cclimcur cursor for
    select cclimits.ID, serverID, sectionID, teststepID, accessID, expression,
      domautoID != groupautoID as af
    from cclimits
    left join loggingtmp.clu using(ID)
    left join loggingtmp.lwids on lwids.ID = clu.usedwID
    where expressionsql != '' and lwids.ID is NULL;
  declare continue handler for not found set z = 1;

  create temporary table ssta
    (primary key(serverID, sectionID, teststepID, accessID))
    select serverID, sectionID, teststepID, accessID
    from lwerteindizes
    group by serverID, sectionID, teststepID, accessID;

  delete cclimits
    from cclimits
    left join ssta using(serverID, sectionID, teststepID, accessID)
    where ssta.serverID is NULL;

  drop temporary table ssta;

  create temporary table loggingtmp.lwids (primary key(ID))
    select ID from lwerteindizes;

  create temporary table loggingtmp.clu (
      ID integer unsigned not null,
      usedwID integer unsigned not null,
      primary key(ID, usedwID));

  open cclimcurids;
  set z = 0;
  fetch cclimcurids into clid, uwids;
  while z != 1 do
    set e = 1;
    set slen = char_length(uwids);
    while e <= slen do
      set d = locate(',', uwids, e);
      if d > 0 then
        insert ignore into loggingtmp.clu (ID, usedwID) values (clid, substring(uwids, e, d-e));
        set e = d + 1;
      else
        insert ignore into loggingtmp.clu (ID, usedwID) values (clid, substring(uwids, e));
        set e = slen + 1;
      end if;
    end while;
    fetch cclimcurids into clid, uwids;
  end while;
  close cclimcurids;

  open cclimcur;
  set z = 0;
  fetch cclimcur into clid, si, ei, ti, aid, fkt, autoflag;
  while z != 1 do
    call convert_ccombi(si, ei, ti, aid, fkt, '', '', q, fdwid, ctype, cnstvars, uwids);
    if q = '' then
      if autoflag then
        delete from cclimits where ID = clid;
      else
        update cclimits set
            expressionsql = '', usedwIDs = ''
          where ID = clid;
      end if;
    else
      update cclimits set
          expressionsql = concat('select ', q), usedwIDs = trim(leading ',' from uwids)
        where ID = clid;
    end if;
    fetch cclimcur into clid, si, ei, ti, aid, fkt, autoflag;
  end while;
  close cclimcur;

  drop temporary table loggingtmp.lwids, loggingtmp.clu;

end //

GRANT EXECUTE on PROCEDURE cleancclimits to loggingadmin@'localhost'//
