-- cleancombidetails.sql
--
-- procedure cleancombidetails()
-- 
-- remove combidetails with deleted details

delimiter //

DROP procedure IF EXISTS cleancombidetails//
create procedure cleancombidetails()
  deterministic
  sql security invoker
 begin

  declare z, e, d, slen, cdid, si, ei, ti, aid, fdwid, autoflag integer unsigned;
  declare q, cnstvars, uwids, fkt varchar(3000);
  declare ctype enum('num','str','dat','blob');
  declare klimcurids cursor for select ID, usedwIDs from kombidetails where usedwIDs != '';
  declare klimcur cursor for
    select kombidetails.ID, serverID, sectionID, teststepID, accessID, formel,
      autokombidetailsID != groupautoID as af
    from kombidetails
    left join loggingtmp.clu using(ID)
    left join loggingtmp.wids on wids.ID = clu.usedwID
    where formelsql != '' and wids.ID is NULL;
  declare continue handler for not found set z = 1;

  create temporary table ssta
    (primary key(serverID, sectionID, teststepID, accessID))
    select serverID, sectionID, teststepID, accessID
    from werteindizes
    group by serverID, sectionID, teststepID, accessID;

  delete kombidetails
    from kombidetails
    left join ssta using(serverID, sectionID, teststepID, accessID)
    where ssta.serverID is NULL;

  drop temporary table ssta;

  create temporary table loggingtmp.wids (primary key(ID))
    select ID from werteindizes;

  create temporary table loggingtmp.clu (
      ID integer unsigned not null,
      usedwID integer unsigned not null,
      primary key(ID, usedwID));

  open klimcurids;
  set z = 0;
  fetch klimcurids into cdid, uwids;
  while z != 1 do
    set e = 1;
    set slen = char_length(uwids);
    while e <= slen do
      set d = locate(',', uwids, e);
      if d > 0 then
        insert ignore into loggingtmp.clu (ID, usedwID) values (cdid, substring(uwids, e, d-e));
        set e = d + 1;
      else
        insert ignore into loggingtmp.clu (ID, usedwID) values (cdid, substring(uwids, e));
        set e = slen + 1;
      end if;
    end while;
    fetch klimcurids into cdid, uwids;
  end while;
  close klimcurids;

  set z = 0;
  open klimcur;
  fetch klimcur into cdid, si, ei, ti, aid, fkt, autoflag;
  while z != 1 do
    call convert_combi(si, ei, ti, aid, fkt, 'b', ',datum', q, fdwid, ctype, cnstvars, uwids);
    if q = '' then
      if autoflag then
        delete from kombidetails where ID = cdid;
      else
        update kombidetails set
            formelsql = '', firstdetwiID = 0, usedwIDs = ''
          where ID = cdid;
      end if;
    else
      update kombidetails set
          formelsql = q, firstdetwiID = fdwid, usedwIDs = trim(leading ',' from uwids)
        where ID = cdid;
    end if;
    set z = 0;
    fetch klimcur into cdid, si, ei, ti, aid, fkt, autoflag;
  end while;
  close klimcur;

  drop temporary table loggingtmp.wids, loggingtmp.clu;

end //

GRANT EXECUTE on PROCEDURE cleancombidetails to loggingadmin@'localhost'//
