-- cleancombilimits.sql
--
-- procedure cleancombilimits()
--
-- remove combilimits with deleted details

delimiter //

DROP procedure IF EXISTS cleancombilimits//
create procedure cleancombilimits()
  deterministic
  sql security invoker
 begin

  declare z, e, d, slen, clid, si, ei, ti, aid, fdwid, autoflag integer unsigned;
  declare q, cnstvars, uwids, fkt varchar(3000);
  declare ctype enum('num','str','dat','blob');
  declare klimcurids cursor for
    select ID, usedwIDs from kombilimits where usedwIDs != '';
  declare klimcur cursor for
    select kombilimits.ID, serverID, sectionID, teststepID, accessID, expression,
      autokombilimitsID != groupautoID as af
    from kombilimits
    left join loggingtmp.clu using(ID)
    left join loggingtmp.wids on wids.ID = clu.usedwID
    where expressionsql != '' and wids.ID is NULL;
  declare continue handler for not found set z = 1;

  create temporary table ssta
    (primary key(serverID, sectionID, teststepID, accessID))
    select serverID, sectionID, teststepID, accessID
    from werteindizes
    group by serverID, sectionID, teststepID, accessID;

  delete kombilimits
    from kombilimits
    left join ssta using(serverID, sectionID, teststepID, accessID)
    where ssta.serverID is NULL;

  drop temporary table ssta;

  create temporary table loggingtmp.wids (primary key(ID))
    select ID from werteindizes;

  create temporary table loggingtmp.clu (
      ID integer unsigned not null,
      usedwID integer unsigned not null,
      primary key(ID, usedwID));

  open klimcurids;
  set z = 0;
  fetch klimcurids into clid, uwids;
  while z != 1 do
    set e = 1;
    set slen = char_length(uwids);
    while e <= slen do
      set d = locate(',', uwids, e);
      if d > 0 then
        insert ignore into loggingtmp.clu (ID, usedwID) values (clid, substring(uwids, e, d-e));
        set e = d + 1;
      else
        insert ignore into loggingtmp.clu (ID, usedwID) values (clid, substring(uwids, e));
        set e = slen + 1;
      end if;
    end while;
    fetch klimcurids into clid, uwids;
  end while;
  close klimcurids;

  open klimcur;
  set z = 0;
  fetch klimcur into clid, si, ei, ti, aid, fkt, autoflag;
  while z != 1 do
    call convert_combi(si, ei, ti, aid, fkt, '', '', q, fdwid, ctype, cnstvars, uwids);
    if q = '' then
      if autoflag then
        delete from kombilimits where ID = clid;
      else
        update kombilimits set
            expressionsql = '', usedwIDs = ''
          where ID = clid;
      end if;
    else
      update kombilimits set
          expressionsql = concat('select ', q), usedwIDs = trim(leading ',' from uwids)
        where ID = clid;
    end if;
    set z = 0;
    fetch klimcur into clid, si, ei, ti, aid, fkt, autoflag;
  end while;
  close klimcur;

  drop temporary table loggingtmp.wids, loggingtmp.clu;

end //

GRANT EXECUTE on PROCEDURE cleancombilimits to loggingadmin@'localhost'//
