-- cleanlwerteindizes.sql
--
-- procedure cleanlwerteindizes()
-- 
-- remove unused lwerteindizes
-- no compressed and online values

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS cleanlwerteindizes//
create procedure cleanlwerteindizes()
  deterministic
  sql security invoker
  begin

    create temporary table wwi (primary key(lwerteindizesID))
      select distinct lwerteindizesID from lwerte
      union distinct
      select distinct lwerteindizesID from mwerte
      union distinct
      select distinct lwerteindizesID from uttevent;

    create temporary table wi
      ( key sstda(`serverID`, `sectionID`, `teststepID`, `teststepdetailsID`, `accessID`) )
      select `serverID`, `sectionID`, `teststepID`, `teststepdetailsID`, `accessID`
      from werteindizes;

    delete lwerteindizes
      from lwerteindizes
      left join wi using(`serverID`, `sectionID`, `teststepID`, `teststepdetailsID`, `accessID`)
      left join wwi on lwerteindizesID = lwerteindizes.ID
      where wi.serverID is NULL and wwi.lwerteindizesID is NULL;

    optimize table lwerteindizes;

    drop temporary table wi, wwi;

  end//

GRANT EXECUTE on PROCEDURE cleanlwerteindizes to loggingadmin@'localhost'//
