-- cleansectstdet.sql
--
-- procedure cleansectstdet()
-- 
-- remove unused sections, teststeps and details

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS cleansectstdet//
create procedure cleansectstdet()
  deterministic
  sql security invoker
  begin
    declare maxid integer unsigned;

    select max(ID) into maxid from section;

    create temporary table si
      ( primary key (sectionID) )
      select distinct werteindizes.sectionID from werteindizes
      union distinct
      select distinct kombidetails.sectionID from kombidetails
      union distinct
      select distinct ccdetails.sectionID from ccdetails
      union distinct
      select distinct kombilimits.sectionID from kombilimits
      union distinct
      select distinct cclimits.sectionID from cclimits
      union distinct
      select distinct uttevent.sectionID from uttevent
      union distinct
      select distinct lwerteindizes.sectionID from lwerteindizes;

    delete section
      from section
      left join si on section.ID=si.sectionID
      where ID < maxid - 10 and sectionID is NULL;

    drop temporary table si;

    select max(ID) into maxid from teststep;

    create temporary table ti
      ( primary key (teststepID) )
      select distinct werteindizes.teststepID from werteindizes
      union distinct
      select distinct kombidetails.teststepID from kombidetails
      union distinct
      select distinct ccdetails.teststepID from ccdetails
      union distinct
      select distinct kombilimits.teststepID from kombilimits
      union distinct
      select distinct cclimits.teststepID from cclimits
      union distinct
      select distinct uttevent.teststepID from uttevent
      union distinct
      select distinct lwerteindizes.teststepID from lwerteindizes;

    delete teststep
      from teststep
      left join ti on teststep.ID = ti.teststepID
      where ID < maxid - 10 and teststepID is NULL;

    drop temporary table ti;

    select max(ID) into maxid from teststepdetails;

    create temporary table di
      ( primary key (teststepdetailsID) )
      select distinct werteindizes.teststepdetailsID from werteindizes
      union distinct
      select distinct kombidetails.teststepdetailsID from kombidetails
      union distinct
      select distinct autokombidetails.teststepdetailsID from autokombidetails
      union distinct
      select distinct gautocombidetails.teststepdetailsID from gautocombidetails
      union distinct
      select distinct ccdetails.teststepdetailsID from ccdetails
      union distinct
      select distinct autoccdetails.teststepdetailsID from autoccdetails
      union distinct
      select distinct gautoccdetails.teststepdetailsID from gautoccdetails
      union distinct
      select distinct uttevent.teststepdetailsID from uttevent
      union distinct
      select distinct lwerteindizes.teststepdetailsID from lwerteindizes;

    delete teststepdetails
      from teststepdetails
      left join di on teststepdetails.ID = di.teststepdetailsID
      where ID < maxid - 10 and teststepdetailsID is NULL;

    drop temporary table di;

  end//

GRANT EXECUTE on PROCEDURE cleansectstdet to loggingadmin@'localhost'//
