-- delallgroupautos.sql
--
-- procedure delallgroupautos(gid)
-- gid: groupID
--
-- remove all gauto*limits for group gid
-- the group gid will be deleted

-- Wird aufgerufen aus Admin-Menue, wenn
-- eine Gruppe gelöscht wird

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS delallgroupautos//
create procedure delallgroupautos(gid int unsigned)
  deterministic
  sql security invoker
 begin
  declare aid, z integer;
  declare vids varchar(20000);
  declare selcur cursor for
    select aid, group_concat(verfahrenID separator ',')
    from gruppenrechte
    where gruppenID = gid
    group by accessID;
  declare continue handler for not found set z = 1;

  open selcur;
  set z = 0;
  fetch selcur into aid, vids;
  while z != 1 do
    call delgroupautos(gid, vids, aid);
    set z = 0;
    fetch selcur into aid, vids;
  end while;
  close selcur;

  delete lwertelimits from lwertelimits, gautoclimits
    where gautoclimits.groupID = gid and lwertelimits.groupautoID = gautoclimits.ID;
  delete from gautoclimits where groupID = gid;

  delete kombidetails from kombidetails, gautocombidetails
    where gautocombidetails.groupID = gid
      and kombidetails.groupautoID = gautocombidetails.ID;
  delete from gautocombidetails where groupID = gid;

  delete ccdetails from ccdetails, gautoccdetails
    where gautoccdetails.groupID = gid
      and ccdetails.groupautoID = gautoccdetails.ID;
  delete from gautoccdetails where groupID = gid;

  delete kombilimits from kombilimits, gautocombilimits
    where gautocombilimits.groupID = gid
      and kombilimits.groupautoID = gautocombilimits.ID;
  delete from gautocombilimits where groupID = gid;

  delete cclimits from cclimits, gautocclimits
    where gautocclimits.groupID = gid
      and cclimits.groupautoID = gautocclimits.ID;
  delete from gautocclimits where groupID = gid;

  delete komprimierungids from komprimierungids, gautocompression
    where gautocompression.groupID = gid
      and komprimierungids.groupautoID = gautocompression.ID;
  delete from gautocompression where groupID = gid;

  delete from gautocrettime where groupID = gid;

  delete isalive from isalive, gautoisalive
    where gautoisalive.groupID = gid
      and isalive.groupautoID = gautoisalive.ID;
  delete from gautoisalive where groupID = gid;

  delete wertelimits from wertelimits, gautolimits
    where gautolimits.groupID = gid
      and wertelimits.groupautoID = gautolimits.ID;
  delete from gautolimits where groupID = gid;

  delete from gautorettime where groupID = gid;

end//

GRANT EXECUTE on PROCEDURE delallgroupautos to loggingadmin@'localhost'//
