-- delrogroupautos.sql
--
-- procedure delrogroupautos(groupids, domids, accid)
-- groupids: set of group IDs
-- domids: set of domain IDs
-- accid: accessID
--
-- remove Read-Only rights for groups/domains 

-- Wird aufgerufen aus Admin-Menue, wenn
-- einer Gruppe RO-Verfahren entfernt
-- werden oder einem Verfahren RO-Gruppen
-- entfernt werden

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS delrogroupautos//
create procedure delrogroupautos(groupids varchar(20000), domids varchar(20000),
                               accid integer unsigned)
  deterministic
  sql security invoker
 begin

  create temporary table loggingtmp.sids (primary key (ID))
    select server.ID from server
      where find_in_set(server.verfahrenID, domids);

  create temporary table loggingtmp.gids (primary key (ID))
    select ID from gruppen where find_in_set(ID, groupids);


-- Kombidetails

  delete kombidetails from kombidetails
    join loggingtmp.sids on sids.ID = kombidetails.serverID
    join gautocombidetails on gautocombidetails.ID = kombidetails.groupautoID
    join loggingtmp.gids on gids.ID = gautocombidetails.groupID
    where kombidetails.accessID = accid;


-- komprimierte Kombidetails

  delete ccdetails from ccdetails
    join loggingtmp.sids on sids.ID = ccdetails.serverID
    join gautoccdetails on gautoccdetails.ID = ccdetails.groupautoID
    join loggingtmp.gids on gids.ID = gautoccdetails.groupID
    where ccdetails.accessID = accid;


  drop temporary table loggingtmp.sids, loggingtmp.gids;

end//

GRANT EXECUTE on PROCEDURE delrogroupautos to loggingadmin@'localhost'//
