-- expand_filename.sql
--
-- function expand_filename(name, ins) returns varchar
-- name: filename
-- ins: text to insert
-- return: <basename of name>_<ins>.<filetype>

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS expand_filename//
create function expand_filename(name varchar(300), ins varchar(20)) returns varchar(320)
  deterministic
  sql security invoker
  begin
    declare p integer unsigned;
    declare e, f varchar(300);

    set e = substring_index(name, '.', -1);
    if find_in_set(e, 'xz,gz,bz2') then
      set f = substring_index(name, '.', -2);
      if f regexp '^cfg[.]|^conf[.]|^text[.]|^txt[.]|^html[.]|^log[.]|^sql[.]|^par[.]' then
        set p = length(name) - length(f);
        set e = f;
      else
        set p = length(name) - length(e);
      end if;
    else
      set p = length(name) - length(e);
    end if;
    if p > 0 then
      return concat(substring(name, 1, p - 1), '_', ins, '.', e);
    else
      return concat(name, '_', ins);
    end if;

  end//

GRANT EXECUTE on FUNCTION expand_filename to 'logginglesen'@'localhost'//
GRANT EXECUTE on FUNCTION expand_filename to 'loggingtest'@'localhost'//
