-- find_all_in_set.sql
--
-- function find_all_in_set(s, t) returns bool
-- s: search set of values
-- t: set of allowed values
-- return: 0 - value in s not found in t, >0 - all values of s are in t
--
-- test for s is subset of t

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS find_all_in_set//
create function find_all_in_set(s varchar(200), t varchar(200)) returns bool
  deterministic
  sql security invoker
  begin
    declare i integer;
    declare ss, sr varchar(200);

    set sr = s;
    set i = instr(sr, ',');
    while i > 0 do
      set ss = left(sr, i-1);
      if not find_in_set(ss, t) then
        return false;
      end if;
      set sr = substring(sr, i+1);
      set i = instr(sr, ',');
    end while;
    return find_in_set(sr, t);
  end//
