set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists gautocclimits_au//
create trigger gautocclimits_au after update on gautocclimits
  for each row
begin
  insert into changeprot
    (groupID, accessID, changedtable, tableID, userID, username, action,
     domain, classes, server, section, teststep, newvalues)
  select groupID, accessID, 'gautocclimits', gautocclimits.ID,
    coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'update',
    showreg(domain, domain_v), showreg(classes, classes_v), showreg(server, server_v),
    showreg(section, section_v), showreg(teststep, teststep_v),
    concat('expression=', expression, '\nrelation=', relation, '\ninfolevel=',
           infolevel, '\nwarnlevel=', warnlevel, '\nerrorlevel=', errorlevel,
           '\nnotifymode=', notifymode, '\nmessage=', REPLACE(REPLACE(meldung, '\\', '\\\\'), '\n', '\\n'),
           '\ndestination1=', notifdestname(meldungszielID),
           '\ndestination2=', notifdestname(meldungsziel2ID), '\nremark=',
           REPLACE(REPLACE(bemerkungen, '\\', '\\\\'), '\n', '\\n'), '\nonlyifnoother=', nootherflag, '\nactive=', aktiv)
  from gautocclimits
  where gautocclimits.ID = NEW.ID and NEW.TS = gautocclimits.TS;
end//


drop trigger if exists gautocclimits_ai//
create trigger gautocclimits_ai after insert on gautocclimits
  for each row
begin
  insert into changeprot
    (groupID, accessID, changedtable, tableID, userID, username, action,
     domain, classes, server, section, teststep, newvalues)
  values
    (NEW.groupID, NEW.accessID, 'gautocclimits', NEW.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'insert',
     showreg(NEW.domain, NEW.domain_v), showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v),
     showreg(NEW.section, NEW.section_v), showreg(NEW.teststep, NEW.teststep_v),
     concat('expression=', NEW.expression, '\nrelation=', NEW.relation, '\ninfolevel=',
            NEW.infolevel, '\nwarnlevel=', NEW.warnlevel, '\nerrorlevel=', NEW.errorlevel,
            '\nnotifymode=', NEW.notifymode, '\nmessage=', REPLACE(REPLACE(NEW.meldung, '\\', '\\\\'), '\n', '\\n'),
            '\ndestination1=', notifdestname(NEW.meldungszielID),
            '\ndestination2=', notifdestname(NEW.meldungsziel2ID), '\nremark=',
            REPLACE(REPLACE(NEW.bemerkungen, '\\', '\\\\'), '\n', '\\n'), '\nonlyifnoother=', NEW.nootherflag, '\nactive=', NEW.aktiv));
end//


drop trigger if exists gautocclimits_bd//
create trigger gautocclimits_bd before delete on gautocclimits
  for each row
begin
  insert into changeprot
    (groupID, accessID, changedtable, tableID, userID, username, action,
     domain, classes, server, section, teststep, newvalues)
  values
    (OLD.groupID, OLD.accessID, 'gautocclimits', OLD.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'delete',
     showreg(OLD.domain, OLD.domain_v), showreg(OLD.classes, OLD.classes_v), showreg(OLD.server, OLD.server_v),
     showreg(OLD.section, OLD.section_v), showreg(OLD.teststep, OLD.teststep_v),
     coalesce(if(OLD.bemerkungen = @cclimitsremark, '', concat('remark=', REPLACE(REPLACE(@cclimitsremark, '\\', '\\\\'), '\n', '\\n'))),''));
end//

delimiter ;
