-- genreg-proc.sql
--
-- procedure genreg(r, OUT i, OUT e)
-- r: ULS-Wildcard
-- i: regexp include
-- e: regexp exclude
--
-- split ULS-Wildcard to include and exclude regexp


set @@character_set_client = 'utf8';

delimiter //
DROP PROCEDURE IF EXISTS genreg//
create procedure genreg(r varchar(4000), OUT i varchar(2000), OUT e varchar(2000))
  deterministic
  sql security invoker
  begin
    declare rx varchar(4000);
    declare ri, re, ra varchar(2000);
    declare k int;

    if r NOT REGEXP '^!|,!' then
      set i = genreg(r);
      set e = '';
    else
      set rx = r;
      set re = '';
      set ri = '';
      while rx != '' do
        set k = instr(rx, ',');
        if k = 0 then
          set ra = rx;
          set rx = '';
        else
          set ra = left(rx, k-1);
          set rx = substring(rx, k+1);
        end if;
        if left(ra, 1) = '!' then
          if re = '' then
            set re = substring(ra, 2);
          else
            set re = concat(re, ',', substring(ra, 2));
          end if;
        else
          if ri = '' then
            set ri = ra;
          else
            set ri = concat(ri, ',', ra);
          end if;
        end if;
      end while;
      set i = genreg(ri);
      set e = genreg(re);
    end if;
  end//

GRANT EXECUTE on PROCEDURE genreg
  to logginglesen@'localhost', loggingadmin@'localhost', logging@'localhost'//
