-- getlastwdate.sql
--
-- function getlastwdate(wid, von, bis) returns datetime
-- wid: werteindizesID
-- von: from datetime
-- bis: to datetime
-- return: datetime of last value between from and to

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS getlastwdate//
create function getlastwdate(wid integer, von datetime(6), bis datetime(6))
                  returns datetime(6)
deterministic
sql security invoker
begin
  declare wt varchar(30);
  select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID = wid and teststepdetailsID = teststepdetails.ID
        and einheitID = einheiten.ID;
  case wt
    when 'swerte' then
      return (select datum from swerte
              where werteindizesID = wid and von <= datum and datum < bis
              order by datum desc limit 1);
    when 'twerte' then
      return (select datum from twerte
              where werteindizesID = wid and von <= datum and datum < bis
              order by datum desc limit 1);
    when 'pwerte' then
      return (select datum from pwerte
              where werteindizesID = wid and von <= datum and datum < bis
              order by datum desc limit 1);
    when 'cwerte' then
      return (select datum from cwerte
              where werteindizesID = wid and von <= datum and datum < bis
              order by datum desc limit 1);
    else
      return (select datum from zwerte
              where werteindizesID = wid and von <= datum and datum < bis
              order by datum desc limit 1);
  end case;
end//

GRANT EXECUTE on FUNCTION getlastwdate to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//
