-- getmunitt.sql
--
-- procedure getmunitt(nn, out ei, out wt)
-- nn: unitname
-- ei: ID of unit in table einheiten
-- wt: table for values
--
-- search or create new entry for microseconds unit {N}<nn>

-- getmunitt Einheit zu Mikrosekunden Zeitstempel bestimmen und ggf. eintragen

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS getmunitt//
create procedure getmunitt(nn varchar(100), out ei integer, out wt varchar(10))
  deterministic
  sql security invoker
 begin
  declare u, v varbinary(100);

  set wt = 'twerte';
  set ei = NULL;
  if nn = '' then
    select ID into ei from einheiten where bname = '{N}';
  else
    set u = trim(nn);
    set v = concat('{N}', u);
    select ID into ei from einheiten
      where (bname = v OR bname = u) and wtab = wt order by bname != u limit 1;
    if ei is NULL then
      select ID into ei from einheiten where bname = u AND sifaktor > 0;
      if ei is not NULL then
        insert ignore into einheiten (name, bname, einheitenID, sifaktor, sioffset, druckflag, plotstyle, bemerkung, wtab, type)
          select name, v, einheitenID, sifaktor, sioffset, druckflag, plotstyle, bemerkung, wt, type
            from einheiten where ID = ei;
        select ID into ei from einheiten where bname = v;
      end if;
    end if;
  end if;
  if ei is NULL then
    insert ignore into einheiten set bname = '{N}', name = '', wtab = wt;
    select ID into ei from einheiten where bname = '{N}';
  end if;

end//

GRANT EXECUTE on PROCEDURE getmunitt to logging@'localhost'//
