-- getswertvbfilter.sql
--
-- function getswertvbfilter(wid, von, bis, mode, zvon, zbis) returns varchar
-- wid: werteindizesID
-- von: datetime from
-- bis: datetime to
-- mode: aggregation function
-- zvon: time from
-- zbis: time to
-- return: aggragated value with time filter (table swerte)

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS getswertvbfilter//
create function getswertvbfilter(wid integer, von datetime, bis datetime,
  mode varchar(12), zvon time, zbis time)
                  returns varchar(20000)
deterministic
sql security invoker
begin
  declare va, ba, vo, bo time;
  if TIME(zvon) < TIME(zbis)
   then
    set va = TIME(zvon);
    set ba = TIME(zbis);
    set vo = '00:00:00';
    set bo = '23:59:59';
  else
    set va = '00:00:00';
    set ba = '23:59:59';
    set vo = TIME(zvon);
    set bo = TIME(zbis);
  end if;
  case mode
    when 'count' then
      return (select count(*) from swerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo));
    when 'first' then
      return (select wert from swerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum, ID limit 1);

    when 'differ' then
      return BINARY (select wert from swerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum desc, ID desc limit 1)
          != BINARY (select wert from swerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum, ID limit 1);
    when 'last' then
      return (select wert from swerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum desc, ID desc limit 1);
    else
      return '';
  end case;
end//

GRANT EXECUTE on FUNCTION getswertvbfilter to logginglesen@'localhost', loggingtest@'localhost'//
