-- getunit.sql
--
-- procedure getunit(nn, out ei)
-- nn: unit name 
-- ei: unit ID (table einheiten)

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS getunit//
create procedure getunit(nn varchar(100), out ei integer)
  deterministic
  sql security invoker
 begin
  declare u varbinary(100);
  if nn = '' then
    set u = ' ';
  else
    set u = trim(nn);
  end if;
  set ei = (select ID from einheiten where bname = u);
  if ei is NULL then
    select ID into ei from einheiten where bname = ' ';
  end if;
end//

GRANT EXECUTE on PROCEDURE getunit to logging@'localhost'//
