-- gradient.sql
--
-- function gradient(wid, hback, faktor) returns varchar
-- wid: werteindizesID
-- hback: hours to go back
-- faktor: hours
-- return: gradient of werteindizesID calculatet of the last hback hours for faktor hours

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradient//
create function gradient(wid integer, hback integer, faktor integer) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID;
    case wt
      when 'cwerte' then return gradientc(wid, hback, faktor);
      when 'pwerte' then return gradientp(wid, hback, faktor);
      else               return gradientz(wid, hback, faktor);
    end case;
end//

GRANT EXECUTE on FUNCTION gradient to logginglesen@'localhost', loggingtest@'localhost'//
