-- gradientc.sql
--
-- function gradientc(wid, hback, faktor) returns varchar
-- wid: werteindizesID
-- hback: hours to go back
-- faktor: hours
-- return: gradient of werteindizesID calculatet of the last hback hours for faktor hours

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradientc//
create function gradientc(wid integer, hback integer, faktor integer) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare vondat, bisdat datetime;
    declare s, u, sx, sxx, syx, sy double;

    select greatest(now(), lastdatum) into bisdat from letztewerte where ID = wid;
    set vondat = bisdat - interval hback hour;
    set u = UNIX_TIMESTAMP();
    select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
           count(datum), sum((wert+0)*(UNIX_TIMESTAMP(datum)-u)), sum((wert+0))
      into sxx, sx, s, syx, sy
      from cwerte
      where werteindizesID = wid and vondat <= datum and datum <= bisdat;
    if sxx > 0
     then
      return 3600*faktor*(syx-sy*sx/s)/(sxx-sx*sx/s);
    else
      return '';
    end if;
end//

GRANT EXECUTE on FUNCTION gradientc to logginglesen@'localhost', loggingtest@'localhost'//
