-- gradientpvbfilter.sql
--
-- function gradientpvbfilter(wid, von, bis, zvon, zbis) returns varchar
-- wid: werteindizesID
-- von: datetime from
-- bis: datetime to
-- zvon: time from
-- zbis: time to
-- return: gradient of values vom "von" to "bis" with timefilter for table pwerte

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradientpvbfilter//
create function gradientpvbfilter(wid integer, von datetime, bis datetime,
  zvon time, zbis time) returns varchar(50)
deterministic
sql security invoker
begin
  declare s, u, sx, sxx, syx, sy double;
  declare va, ba, vo, bo time;
  if TIME(zvon) < TIME(zbis)
   then
    set va = TIME(zvon);
    set ba = TIME(zbis);
    set vo = '00:00:00';
    set bo = '23:59:59';
  else
    set va = '00:00:00';
    set ba = '23:59:59';
    set vo = TIME(zvon);
    set bo = TIME(zbis);
  end if;
  set u = UNIX_TIMESTAMP(von);
  select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
         count(datum), sum((wert+0)*(UNIX_TIMESTAMP(datum)-u)),
         sum((wert+0))
    into sxx, sx, s, syx, sy
    from pwerte
    where werteindizesID = wid and von <= datum and datum <= bis
      and ((va <= TIME(datum) and TIME(datum) <= ba)
           or vo <= TIME(datum) or TIME(datum) <= bo);
  if sxx > 0
   then
    return 3600*(syx-sy*sx/s)/(sxx-sx*sx/s);
  else
     return '';
  end if;
end//

GRANT EXECUTE on FUNCTION gradientpvbfilter to logginglesen@'localhost', loggingtest@'localhost'//
