-- gradientvb.sql
--
-- function gradientvb(wid, von, bis) returns varchar
-- wid: werteindizesID
-- von: datetime from
-- bis: datetime to
-- return: gradient of values

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradientvb//
create function gradientvb(wid integer, von datetime, bis datetime) returns varchar(50)
deterministic
sql security invoker
begin
  declare wt varchar(30);
  declare v, b datetime;
  select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID;
  if bis = von
   then
    set b = '9999-12-31 23:59:59';
  else
    set b = bis;
  end if;
  case wt
    when 'cwerte' then return gradientcvb(wid, von, b);
    when 'pwerte' then return gradientpvb(wid, von, b);
    else               return gradientzvb(wid, von, b);
  end case;
end//

GRANT EXECUTE on FUNCTION gradientvb to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//
