-- gradientvbextfilter.sql
--
-- function gradientvbextfilter(wid, von, bis, zvon, zbis, wtf, vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4) returns varchar
-- wid: werteindizesID
-- von: datetime from
-- bis: datetime to
-- zvon: time from
-- zbis: time to
-- wtf: set of weekdays
-- vg1: comparevalue 1
-- wf1: comparefunction 1
-- m2: OR|AND
-- vg2: comparevalue 2
-- wf2: comparefunction 2
-- m3: OR|AND
-- vg3: comparevalue 3
-- wf3: comparefunction 3
-- m4: OR|AND
-- vg4: comparevalue 4
-- wf4: comparefunction 4
-- return: gradient of values with extended filter

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradientvbextfilter//
create function gradientvbextfilter(wid integer, von datetime, bis datetime,
  zvon time, zbis time, wtf varchar(20),
  vg1 varchar(3), wf1 varchar(250),
  m2 varchar(3), vg2 varchar(3), wf2 varchar(250),
  m3 varchar(3), vg3 varchar(3), wf3 varchar(250),
  m4 varchar(3), vg4 varchar(3), wf4 varchar(250)) returns varchar(50)
deterministic
sql security invoker
begin
  declare wt varchar(30);
  declare v, b datetime;
  select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID;
  if bis = von
   then
    set b = '9999-12-31 23:59:59';
  else
    set b = bis;
  end if;
  case wt
    when 'cwerte' then return gradientcvbextfilter(wid, von, b, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
    when 'pwerte' then return gradientpvbextfilter(wid, von, b, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
    else               return gradientzvbextfilter(wid, von, b, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
  end case;
end//

GRANT EXECUTE on FUNCTION gradientvbextfilter to logginglesen@'localhost'//
