-- gradientvbfilter.sql
--
-- function gradientvbfilter(wid, von, bis, zvon, zbis) returns varchar
-- wid: werteindizesID
-- von: datetime from
-- bis: datetime to
-- zvon: time from
-- zbis: time to
-- return: gradient of values vom "von" to "bis" with timefilter


set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradientvbfilter//
create function gradientvbfilter(wid integer, von datetime, bis datetime,
  zvon time, zbis time) returns varchar(50)
deterministic
sql security invoker
begin
  declare wt varchar(30);
  declare b datetime;
  select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID;
  if bis = von
   then
    set b = '9999-12-31 23:59:59';
  else
    set b = bis;
  end if;
  case wt
    when 'cwerte' then return gradientcvbfilter(wid, von, b, zvon, zbis);
    when 'pwerte' then return gradientpvbfilter(wid, von, b, zvon, zbis);
    else               return gradientzvbfilter(wid, von, b, zvon, zbis);
  end case;
end//

GRANT EXECUTE on FUNCTION gradientvbfilter to logginglesen@'localhost', loggingtest@'localhost'//
