-- groupbwert.sql
--
-- function groupbwert(wid, back, mode) returns varchar
-- wid: werteindizesID
-- back: number or <n>[mhd]
-- mode: aggregate function
-- return: aggregation of the last "back" values for binary data - table bwerte

-- combined details
-- combined limits
-- limits_list
-- test_limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS groupbwert//
create function groupbwert(wid integer, back varchar(10), mode varchar(12))
                          returns varchar(300)
  deterministic
  sql security invoker
  begin
    declare anz integer;
    declare vondat, bisdat datetime;

    set anz = back + 0;
    select greatest(now(), lastdatum) into bisdat from letztewerte where ID = wid;
    case right(back, 1)
      when 'm' then
        set vondat = bisdat - interval anz minute;
      when 'h' then
        set vondat = bisdat - interval anz hour;
      when 'd' then
        set vondat = bisdat - interval anz day;
      else
        return modebwert(wid, back, mode);
    end case;
    return getbwertvb(wid, vondat, bisdat, mode);
end//

GRANT EXECUTE on FUNCTION groupbwert to logginglesen@'localhost', loggingtest@'localhost'//
