-- groupewertu.sql
--
-- function groupewertu(wid, back, mode, neh) returns varchar
-- wid: werteindizesID
-- back: number or <n>[mhd]
-- mode: aggregate function
-- neh: return unit
-- return: aggregation of the last "back" values for unit '[E]'

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS groupewertu//
create function groupewertu(wid integer, back varchar(10), mode varchar(12), neh varchar(100))
                returns varchar(300)
  deterministic
  sql security invoker
  begin
    declare anz integer;
    declare vondat, bisdat datetime;

    set anz = back + 0;
    select greatest(now(), lastdatum) into bisdat from letztewerte where ID = wid;
    case right(back, 1)
      when 'm' then
        set vondat = bisdat - interval anz minute;
      when 'h' then
        set vondat = bisdat - interval anz hour;
      when 'd' then
        set vondat = bisdat - interval anz day;
      else
        return modeewertu(wid, back, mode, neh);
    end case;
    return getewertvbextfilteru(wid, vondat, bisdat, mode, '00:00:00', '23:59:59', '',
             '', '', '', '', '',  '', '', '', '', '', '', neh);
end//

GRANT EXECUTE on FUNCTION groupewertu
  to logginglesen@'localhost', loggingtest@'localhost'//
