-- grouplwert.sql
--
-- function grouplwert(lwid, back, mode) returns varchar
-- lwid: lwerteindizesID
-- back: number or <n>[mhd]
-- mode: aggregate function
-- return: aggregation of the last "back" values for count-values - table lwerte

-- combined aggregation limits
-- combined aggregation details

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS grouplwert//
create function grouplwert(lwid integer, back varchar(10), mode varchar(12))
                          returns varchar(30)
  deterministic
  sql security invoker
  begin
    declare anz integer;
    declare vondate datetime;
    set anz = back + 0;
    case right(back, 1)
      when 'm' then
        set vondate = now() - interval anz minute;
      when 'h' then
        set vondate = now() - interval anz hour;
      when 'd' then
        set vondate = now() - interval anz day;
      else
        return modelwert(lwid, back, mode);
    end case;
    return getlwertvb(lwid, vondate, now(), mode);
end//

GRANT EXECUTE on FUNCTION grouplwert to logginglesen@'localhost', loggingtest@'localhost'//
