-- groupmwert.sql
--
-- function groupmwert(lwid, back, mode) returns varchar
-- wid: werteindizesID
-- back: number or <n>[mhd]
-- mode: aggregate function
-- return: aggregation of the last "back" values for compressed-values - table mwerte

-- combined aggregation details

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS groupmwert//
create function groupmwert(lwid integer, back varchar(10), mode varchar(12))
                          returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare anz integer;
    declare vondate datetime;
    set anz = back + 0;
    case right(back, 1)
      when 'm' then
        set vondate = now() - interval anz minute;
      when 'h' then
        set vondate = now() - interval anz hour;
      when 'd' then
        set vondate = now() - interval anz day;
      else
        return modemwert(lwid, back, mode);
    end case;
    return getmwertvb(lwid, vondate, now(), mode);
end//

GRANT EXECUTE on FUNCTION groupmwert to logginglesen@'localhost', loggingtest@'localhost'//
