-- grouppwertb.sql
--
-- function grouppwertb(wid, bis, back, mode) returns varchar
-- wid: werteindizesID
-- bis: endtime for aggregation
-- back: number or <n>[mhd]
-- mode: aggregate function
-- return: aggregation of the "back" values up to "bis" for table pwerte

-- combined details
-- combined limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS grouppwertb//
create function grouppwertb(wid integer, bis datetime, back varchar(10), mode varchar(12))
                          returns varchar(30)
  deterministic
  sql security invoker
  begin
    declare bm, bh integer;

    case right(back, 1)
      when 'm' then
        set bm = back + 0;
      when 'h' then
        set bm = (back + 0)*60;
      when 'd' then
        set bm = (back + 0)*1440;
      else
        return modepwertb(wid, bis, back, mode);
    end case;
    if find_in_set(mode, 'last,first,size,firstsize,lastsize,differ,last/avg,last/avg-1') then
      return getpwertvb(wid, bis - interval bm minute, bis, mode);
    else
      set bh = bm / 2;
      return getpwertvb(wid, bis - interval (bm-bh) minute, bis + interval bh minute, mode);
   end if;
end//

GRANT EXECUTE on FUNCTION grouppwertb to logginglesen@'localhost', loggingtest@'localhost'//
