-- groupwertbb.sql
--
-- function groupwertbb(wid, bis, back, mode) returns varchar
-- wid: werteindizesID
-- bis: endtime for aggregation
-- back: number or <n>[mhd]
-- mode: aggregate function
-- return: aggregation of the "back" values up to "bis" for table bwerte

-- test_limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS groupwertbb//
create function groupwertbb(wid integer, bis datetime, back varchar(10), mode varchar(12))
                returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare bm, bh integer;

    case right(back, 1)
      when 'm' then
        set bm = back + 0;
      when 'h' then
        set bm = (back + 0)*60;
      when 'd' then
        set bm = (back + 0)*1440;
      else
        return modewertb(wid, bis, back, mode);
    end case;
    return getwertvb(wid, bis - interval bm minute, bis, mode);
end//

GRANT EXECUTE on FUNCTION groupwertbb to logginglesen@'localhost', loggingtest@'localhost'//
