-- ipset.sql
--
-- function ipset(ips, ipset) returns bool
-- ips: ip-address
-- ipset: set of ip-addresses/ranges
-- return: true if ips is element of ipset
--
-- old unused function

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS ipset//
create function ipset(ips varchar(20), ipset varchar(1500)) returns bool
  deterministic
  sql security invoker
  begin
    declare i, b integer;
    declare ip, vip int unsigned;
    declare tips varchar(1500);
    declare tip varchar(20);

    set ip = INET_ATON(ips);
    set tips = ipset;
    while tips != ''
     do
      set i = instr(tips, ',');
      if i = 0
       then
        set tip = tips;
        set tips = '';
      else
        set tip = left(tips, i-1);
        set tips = substring(tips, i+1);
      end if;
      if tip != ''
       then
        set i = instr(tip, '/');
        if i = 0
         then
          if tip = ips
           then
            return true;
          end if;
        else
          set b = 32 - substring(tip, i+1);
          set vip = INET_ATON(left(tip, i-1));
          if ip >> b = vip >> b
           then
            return true;
          end if;
        end if;
      end if;
    end while;
    return false;
  end//

grant EXECUTE on FUNCTION ipset to logging@'localhost', logginglesen@'localhost'//
