-- ipstartend2a.sql
--
-- function ipstartend2a(ipstart, ipend) returns varchar(40)
-- ipstart: IP-addresses start
-- ipend:   IP-adderesses end
-- returns: IP-addresses ascii / netbits

set @@character_set_client = 'utf8';

delimiter //
drop function if exists ipstartend2a//
create function ipstartend2a(ipstart varchar(32), ipend varchar(32)) returns varchar(40)
deterministic
sql security invoker
begin

  return case when length(ipstart) = 8
      then concat(inet_ntoa(conv(ipstart, 16, 10) & conv(ipend, 16, 10)),
                  if(0 < conv(ipstart, 16, 10) ^ conv(ipend, 16, 10),
                      concat('/', 32 - length(conv(conv(ipstart, 16, 10) ^ conv(ipend, 16, 10), 10, 2))),''))
      when 0 = conv(substr(ipstart, 17), 16, 10) ^ conv(substr(ipend, 17), 16, 10) then
        inet6_ntoa(unhex(ipstart))
      when 18446744073709551615 > conv(substr(ipstart, 17), 16, 10) ^ conv(substr(ipend, 17), 16, 10) then
        concat(inet6_ntoa(unhex(concat(left(ipstart, 16), conv(conv(substr(ipstart, 17), 16, 10) & conv(substr(ipend, 17), 16, 10), 10, 16)))),
                '/', 128 - length(conv(conv(substr(ipstart, 17), 16, 10) ^ conv(substr(ipend, 17), 16, 10), 10, 2)))
      else
        concat(inet6_ntoa(unhex(concat(conv(conv(left(ipstart, 16), 16, 10) & conv(left(ipend, 16), 16, 10), 10, 16), '0000000000000000'))),
                '/', 64 - length(conv(conv(left(ipstart, 16), 16, 10) ^ conv(left(ipend, 16), 16, 10), 10, 2)))
      end;
end//
