-- issub.sql
--
-- function issub(n, s) returns integer
-- n: teststepname
-- s: selected teststep with subteststeps
-- return: 1 if n is unter s

-- Prüfen, ob <n> ein Name mit einem ':' unterhalb von <s> ist
-- Rückgabe: Position des ':' oder 0

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS issub//
create function issub(n varchar(500), s varchar(500)) returns integer
  deterministic
  sql security invoker
  begin
    declare i integer;

    set i = locate(':', replace(n,'::','..'), char_length(s)+2);
    return case when 1 < i AND i < char_length(n) then i else 0 end;

  end//

GRANT EXECUTE on FUNCTION issub to logginglesen@'localhost', loggingadmin@'localhost'//
delimiter ;
