set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists mailreports_au//
create trigger mailreports_au after update on mailreports
  for each row
begin
  insert into changeprot
    (changedtable, tableID, userID, groupID, username, action, newvalues)
  select 'mailreports', mailreports.ID,
    coalesce(@userid,0), if(reports.userID > 0, 0, reports.groupID),
    coalesce(@username,'SYSTEM'), 'update',
    concat('report=', reports.name,
           '\nweekdays=', weekdaynames(weekdays),
           '\nhours=', getrange(hours),
           '\nmdays=', getrange(mdays),
           '\nemail=', email,
           '\ndestination=', notifdestname(meldungszielID),
           '\nfilename=', dateiname,
           '\npagebreaks=', pagebreaks,
           '\nactive=', active,
           '\nsubject=', REPLACE(REPLACE(left(subject, 100), '\\', '\\\\'), '\n', '\\n'),
           '\nmailbody=', REPLACE(REPLACE(left(mailbody, 100), '\\', '\\\\'), '\n', '\\n'))
  from mailreports
  join reports on reports.ID = reportsID
  where mailreports.ID = NEW.ID and mailreports.TS = NEW.TS;
end//

drop trigger if exists mailreports_ai//
create trigger mailreports_ai after insert on mailreports
  for each row
begin
  insert into changeprot
    (changedtable, tableID, userID, groupID, username, action, newvalues)
  select 'mailreports', NEW.ID,
    coalesce(@userid,0), if(reports.userID > 0, 0, reports.groupID),
    coalesce(@username,'SYSTEM'), 'insert',
    concat('report=', reports.name,
           '\nweekdays=', weekdaynames(NEW.weekdays),
           '\nhours=', getrange(NEW.hours),
           '\nmdays=', getrange(NEW.mdays),
           '\nemail=', NEW.email,
           '\ndestination=', notifdestname(NEW.meldungszielID),
           '\nfilename=', NEW.dateiname,
           '\npagebreaks=', NEW.pagebreaks,
           '\nactive=', NEW.active,
           '\nsubject=', REPLACE(REPLACE(left(NEW.subject, 100), '\\', '\\\\'), '\n', '\\n'),
           '\nmailbody=', REPLACE(REPLACE(left(NEW.mailbody, 100), '\\', '\\\\'), '\n', '\\n'))
  from reports
  where reports.ID = NEW.reportsID;
end//

drop trigger if exists mailreports_bd//
create trigger mailreports_bd before delete on mailreports
  for each row
begin
  insert into changeprot (changedtable, tableID, userID, groupID, username, action)
  select 'mailreports', OLD.ID,
    coalesce(@userid, 0), if(reports.userID > 0, 0, reports.groupID),
    coalesce(@username, 'SYSTEM'), 'delete'
  from reports
  where reports.ID = OLD.reportsID;
end//

delimiter ;
