-- meldzielname.sql
--
-- function meldzielname(mid) returns varchar
-- mid: meldungsziele.ID
-- return: concat(meldungszielarten.name, ':', kurzname)

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS meldzielname//
create function meldzielname(mid integer) returns varchar(200)
  deterministic
  sql security invoker
  begin
    return (select concat(meldungszielarten.name, ':', kurzname)
            from meldungsziele, meldungszielarten
            where meldungsziele.ID = mid and meldungszielartenID = meldungszielarten.ID);
  end//

GRANT EXECUTE on FUNCTION meldzielname to logginglesen@'localhost', loggingtest@'localhost'//
