-- modebwert.sql
--
-- function modebwert(wid, anz, mode) returns varchar
-- wid: werteindizesID
-- anz: number of values
-- mode: aggregation mode
-- return: aggregated value of the last "anz" binary values with werteindizesID == "wid" (table bwerte)

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS modebwert//
create function modebwert(wid integer, anz integer, mode varchar(12)) returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare counter, z integer;
    declare d, dlast bigint unsigned;
    declare selcur cursor for select datenID from bwerte
      where werteindizesID = wid order by datum desc;
    declare continue handler for not found set z = 1;
    set counter = 0;
    set z = 0;
    if mode = 'size' or mode = 'lastsize' then
      set anz = 1;
      set mode = 'firstsize';
    end if;
    open selcur;
    repeat
      fetch selcur into d;
      if z != 1
       then
        if counter = 0 then
          set dlast = d;
        end if;
        set counter = counter + 1;
      end if;
      until (counter >= anz || z = 1)
    end repeat;
    close selcur;
    if counter >= anz && counter > 0
     then
      case mode
        when 'count' then
          return counter;
        when 'differ' then
          return d != dlast;
        when 'firstsize' then
          return (select length(daten) from daten where ID=d);
        else
          return "";
      end case;
    else
      return "";
    end if;
  end//

GRANT EXECUTE on FUNCTION modebwert to logginglesen@'localhost', loggingtest@'localhost'//
