-- modemwert.sql
--
-- function modemwert(lwid, anz, mode) returns varchar
-- lwid: lwerteinidzesID
-- anz: number of values
-- mode: aggregation mode
-- return: aggregated value of the last "anz" values before "bis" with werteindizesID == "wid" (table mwerte)

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS modemwert//
create function modemwert(lwid integer, anz integer, mode varchar(12))
    returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare counter, z integer;
    declare w, wmin, wmax, wlast varchar(20000);
    declare selcur cursor for select wert from mwerte
      where lwerteindizesID = lwid order by datum desc;
    declare continue handler for not found set z = 1;

    if anz = 1 OR mode = 'last' then
      return (select wert from mwerte
              where lwerteindizesID = lwid order by datum desc limit 1);
    end if;

    set counter = 0;
    set z = 0;
    open selcur;
    repeat
      fetch selcur into w;
      if z != 1
       then
        if counter = 0 then
          set wmin = w;
          set wmax = w;
          set wlast = w;
        else
          if w < wmin then
            set wmin = w;
          end if;
          if w > wmax then
            set wmax = w;
          end if;
        end if;
        set counter = counter + 1;
      end if;
      until (counter >= anz || z = 1)
    end repeat;
    close selcur;
    if counter >= anz && counter > 0
     then
      case mode
        when 'count' then
          return counter;
        when 'min' then
          return wmin;
        when 'max' then
          return wmax;
        when 'first' then
          return w;
        when 'differ' then
          return w != wlast;
        else
          return "";
      end case;
    else
      return "";
    end if;
  end//

GRANT EXECUTE on FUNCTION modemwert to logginglesen@'localhost', loggingtest@'localhost'//
