-- modeswertb.sql
--
-- function modeswertb(wid, bis, anz, mode) returns varchar
-- wid: werteindizesID
-- bis: up to datetime
-- anz: number of values
-- mode: aggregation mode
-- return: aggregated value of the last "anz" values before "bis" with werteindizesID == "wid" (table swerte)

-- modeswertb
--
-- get grouped value from swerte - fixed number of values
--
-- call from
-- modewertb

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS modeswertb//
create function modeswertb(wid integer, bis datetime, anz integer, mode varchar(12))
    returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare counter, z integer;
    declare w, wmin, wmax, wlast varchar(20000);
    declare selcur cursor for select wert from swerte
      where werteindizesID = wid and datum <= bis order by datum desc, id desc;
    declare continue handler for not found set z = 1;

    set counter = 0;
    set z = 0;
    if mode = 'size' or mode = 'lastsize' then
      set anz = 1;
      set mode = 'firstsize';
    elseif mode = 'last' then
      set anz = 1;
      set mode = 'first';
    end if;
    open selcur;
    repeat
      fetch selcur into w;
      if z != 1
       then
        if counter = 0 then
          set wmin = w;
          set wmax = w;
          set wlast = w;
        else
          if w < wmin then
            set wmin = w;
          end if;
          if w > wmax then
            set wmax = w;
          end if;
        end if;
        set counter = counter + 1;
      end if;
      until (counter >= anz || z = 1)
    end repeat;
    close selcur;
    if counter >= anz && counter > 0
     then
      case mode
        when 'count' then
          return counter;
        when 'min' then
          return wmin;
        when 'max' then
          return wmax;
        when 'first' then
          return w;
        when 'differ' then
          return w != wlast;
        when 'firstsize' then
          return length(w);
        else
          return '';
      end case;
    else
      return '';
    end if;
  end//

GRANT EXECUTE on FUNCTION modeswertb to logginglesen@'localhost', loggingtest@'localhost'//
