-- modewert.sql
--
-- function modewert(wid, anz, mode) returns varchar
-- wid: werteindizesID
-- anz: number of values
-- mode: aggregation mode
-- return: aggregated value of the last "anz" values with werteindizesID == "wid"

-- combined details
-- combined limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS modewert//
create function modewert(wid integer, anz integer, mode varchar(12)) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare i integer;
    declare wt varchar(30);
    declare e, w varchar(100);
    select wtab, einheiten.name into wt, e from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID;
    case wt
      when 'bwerte' then return modebwert(wid, anz, mode);
      when 'swerte' then return modeswert(wid, anz, mode);
      when 'twerte' then 
        if e = '[E]' then
          select lastwert into e from letztewerte where ID = wid;
          set i = instr(e, ' ');
          if i > 0 then
            set e = substr(e, i+1);
            set w = modeewert(wid, anz, mode, e);
            if w = '' OR mode = 'count' then
              return w;
            elseif mode = 'grad' then
              return concat(w, ' ', e, '/h');
            elseif mode = 'accel' then
              return concat(w, ' ', e, '/h²');
            else
              return concat(w, ' ', e);
            end if;
          else
            return '';
          end if;
        else
          return modetwert(wid, anz, mode);
        end if;
      when 'cwerte' then return modecwert(wid, anz, mode);
      when 'pwerte' then return modepwert(wid, anz, mode);
      else               return modezwert(wid, anz, mode);
    end case;
  end//

GRANT EXECUTE on FUNCTION modewert to logginglesen@'localhost', loggingtest@'localhost'//
