-- modewertb.sql
--
-- function modewertb(wid, bis, anz, mode) returns varchar
-- wid: werteindizesID
-- bis: up to datetime
-- anz: number ob values
-- mode: aggregation mode
-- return: aggregated value of the last "anz" values before "bis" with werteindizesID == "wid"

-- combined details
-- combined limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS modewertb//
create function modewertb(wid integer, bis datetime(6), anz integer, mode varchar(12)) returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID = wid and teststepdetailsID = teststepdetails.ID
        and einheitID = einheiten.ID;
    case wt
      when 'bwerte' then return modebwertb(wid, bis, anz, mode);
      when 'swerte' then return modeswertb(wid, bis, anz, mode);
      when 'twerte' then return modetwertb(wid, bis, anz, mode);
      when 'cwerte' then return modecwertb(wid, bis, anz, mode);
      when 'pwerte' then return modepwertb(wid, bis, anz, mode);
      else               return modezwertb(wid, bis, anz, mode);
    end case;
  end//

GRANT EXECUTE on FUNCTION modewertb to logginglesen@'localhost', loggingtest@'localhost'//
