-- newautoserver.sql
--
-- function newautoserver(srvname, sip) returns integer unsigned
-- srvname: servername
-- sip: server ip-address
-- returns new server.ID
--
-- create new server from autoserver (domainacceptips)

set @@character_set_client = 'utf8';

delimiter //

DROP function IF EXISTS newautoserver//
create function newautoserver(srvname varchar(200), sip varchar(39)) returns integer
  deterministic
  sql security invoker
 begin
  declare i, domid, si integer unsigned;
  declare n varchar(50);
  declare sn varchar(60);
  declare dom varchar(200);
  declare nrem varchar(3000);

  set i = instr(srvname, '.');
  if i = 0 then
    select ID, serverdomain, remark into domid, dom, nrem
      from domainacceptips
      where ipstart <= hex(inet6_aton(sip)) and hex(inet6_aton(sip)) <= ipend
      order by ipend limit 1;
  else
    select ID, serverdomain into domid, dom, nrem
      from domainacceptips
      where ipstart <= hex(inet6_aton(sip)) and hex(inet6_aton(sip)) <= ipend and substring(srvname, i+1) = dom
      order by ipend limit 1;
    set srvname = left(srvname, i-1);
  end if;
  if domid is NULL then
    return NULL;
  else
    if (select ID from server where servername = srvname and fqdn = concat(srvname,'.',dom) and state != 'inactive') then
      return NULL;
    end if;
    set sn = concat('@A', coalesce((select substr(sin, 3) from server where sin like '@A%' order by sin desc limit 1), 0) + 1);
    if is_ipv6(sip) then
      insert ignore into server
        (verfahrenID, sin, servername, fqdn, ipv6, state, beschreibung)
        VALUES
        (domid, sn, srvname, concat(srvname,'.',dom), inet6_aton(sip), 'noalarms', nrem);
    else
      insert ignore into server
        (verfahrenID, sin, servername, fqdn, ip, state, beschreibung)
        VALUES
        (domid, sn, srvname, concat(srvname,'.',dom), inet_aton(sip), 'noalarms', nrem);
    end if;
    return (select ID from server where servername = srvname and fqdn = concat(srvname,'.',dom));
  end if;

end//

GRANT EXECUTE on FUNCTION newserver to logging@'localhost'//
