-- newserver.sql
--
-- function newserver(domid, ext) returns integer unsigned
-- domid: domain-ID
-- ext: extension in DOMAIN:<servername>:<extension>
-- returns new server.ID
--
-- create new virtual server for @-entries

set @@character_set_client = 'utf8';

delimiter //

DROP function IF EXISTS newserver//
create function newserver(domid integer, ext varchar(50)) returns integer unsigned
  deterministic
  sql security invoker
 begin
  declare si integer unsigned;
  declare n varchar(50);
  declare sn varchar(60);
  declare m varchar(200);

  if ext = '' then
    select concat('@', name), concat('@',domid), concat('@', name, '.', name)
      from verfahren where ID = domid
      into n, sn, m;
  else
    select concat('@', ext), concat('@', ext, '.', domid), concat('@', ext, '.', name)
      from verfahren where ID = domid
      into n, sn, m;
  end if;
  set si = (select ID from server where verfahrenID = domid and sin = sn);
  if si is NULL then
    set si = coalesce((select ID from serverclasses where name = ext), 0);
    insert ignore into server
      (verfahrenID, sin, servername, fqdn, beschreibung, serverclassesID)
      VALUES
      (domid, sn, n, m, m, si);
    set si = (select ID from server where verfahrenID = domid and sin = sn);
  end if;

  return si;
end//
