-- notifdestname.sql
--
-- function notifdestname(id) returns varchar
-- id: meldungsziele.ID
-- return: concat(meldungszielarten.name, ':', meldungsziele.kurzname)

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS notifdestname//
create function notifdestname(id integer unsigned) returns varchar(280)
  deterministic
  sql security invoker
  begin

  return coalesce((select concat(meldungszielarten.name, ':', meldungsziele.kurzname)
           from meldungsziele, meldungszielarten
           where meldungsziele.ID = id
             and meldungszielarten.ID = meldungsziele.meldungszielartenID), '');
end//

GRANT EXECUTE on FUNCTION notifdestname
  to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//
