-- prediction.sql
--
-- function prediction(wid, hback, hforw) returns varchar
-- wid: werteindizesID
-- hback: hours to go back
-- hforw: hours to go forward
-- return: calculate a prediction for the value with "werteindizesID" in hforw hours from
--         the past hback hours

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS prediction//
create function prediction(wid integer, hback integer, hforw integer) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID;
    case wt
      when 'cwerte' then return predictionc(wid, hback, hforw);
      when 'pwerte' then return predictionp(wid, hback, hforw);
      else               return predictionz(wid, hback, hforw);
    end case;
  end//

GRANT EXECUTE on FUNCTION prediction to logginglesen@'localhost', loggingtest@'localhost'//
