-- predictionb.sql
--
-- function predictionb(wid, dt, hback, hforw) returns varchar
-- wid: werteindizesID
-- dt: datetime
-- hback: hours to go back
-- hforw: hours to go forward
-- return: calculate a prediction for the value with "werteindizesID" in hforw hours after dt from
--         the hback hours before dt

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS predictionb//
create function predictionb(wid integer, dt datetime, hback integer, hforw integer) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab into wt from werteindizes join teststepdetails on teststepdetails.ID = teststepdetailsID
    join einheiten on einheiten.ID = einheitID
      where werteindizes.ID = wid;
    case wt
      when 'cwerte' then return predictioncb(wid, dt, hback, hforw);
      when 'pwerte' then return predictionpb(wid, dt, hback, hforw);
      else               return predictionzb(wid, dt, hback, hforw);
    end case;
  end//
