-- predictioncb.sql
--
-- function predictioncb(wid, dt, hback, hforw) returns varchar
-- wid: werteindizesID
-- dt: datetime
-- hback: hours to go back
-- hforw: hours to go forward
-- return: calculate a prediction for the value with "werteindizesID" in hforw hours after dt from
--         the hback hours before dt
-- table cwerte

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS predictioncb//
create function predictioncb(wid integer, dt datetime, hback integer, hforw integer) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare vondate datetime;
    declare s, u, sx, sxx, syx, sy double;
    set vondate = dt - interval hback hour;
    set u = UNIX_TIMESTAMP(dt + interval hforw hour);
    select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
           count(datum), sum((wert+0)*(UNIX_TIMESTAMP(datum)-u)),
           sum((wert+0))
      into sxx, sx, s, syx, sy
      from cwerte
      where werteindizesID = wid and vondate <= datum and datum <= dt;
    if sxx > 0 && s > 1
     then
      return (sy-sx*syx/sxx)/(s-sx*sx/sxx);
    else
      return NULL;
    end if;
  end//
