-- predictioneu.sql
--
-- function predictioneu(wid, hback, hforw, outunit) returns varchar
-- wid: werteindizesID
-- hback: hours to go back
-- hforw: hours to go forward
-- unit: outunit for output
-- return: calculate a prediction for the value with "werteindizesID" in hforw hours from
--         the past hback hours
-- table twerte unit '[E]’

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS predictioneu//
create function predictioneu(wid integer, hback integer, hforw integer, outunit varchar(20)) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare vondate datetime;
    declare s, u, sx, sxx, syx, sy double;
    set vondate = now() - interval hback hour;
    set u = UNIX_TIMESTAMP(now() + interval hforw hour);
    select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
           count(datum), sum((ehwconv(wert, outunit)+0)*(UNIX_TIMESTAMP(datum)-u)),
           sum((ehwconv(wert, outunit)+0))
      into sxx, sx, s, syx, sy
      from twerte
      where werteindizesID = wid and vondate <= datum and datum <= now();
    if sxx > 0 && s > 1
     then
      return (sy-sx*syx/sxx)/(s-sx*sx/sxx);
    else
      return NULL;
    end if;
  end//

GRANT EXECUTE on FUNCTION predictioneu to logginglesen@'localhost', loggingtest@'localhost'//
