-- prepgrouplimits.sql
--
-- procedure prepgrouplimits()
-- string für %option Elemente der Gruppe @groupid vorbereiten
-- zur Anzeige der Gruppenlimits einer Gruppe
--
-- Aufruf als:
--   %mysqlwrite("call prepgrouplimits()")
--   %option z%mysqlvalue(0) " " %mysqlread("execute gls"), %mysqlvalue(3);


set @@character_set_client = 'utf8';

delimiter //

DROP PROCEDURE IF EXISTS prepgrouplimits//
create procedure prepgrouplimits()
deterministic
sql security invoker
begin
  prepare gls from '
     select concat(lt, ID, \':"\', n, mastergrp, \': \',
              replace(if(rem = \'\' OR nl = 1, dcsst, replace(left(rem, if(nl>0, least(nl-1, 30), 30)), \'\\\\\', \'\\\\\\\\\')), \'"\', \'\\\'\'),
              \'":"\', replace(concat(dcsst, \'\\n\', replace(rem, \'\\\\\', \'\\\\\\\\\')), \'"\', \'&quot;\'), \'"\') as l
     from (
         select \'L\' as lt, ID, \'limit\' as n, bemerkungen as rem, locate(\'\\n\', bemerkungen) as nl,
             concat(showreg(domain, domain_v), \'|\', showreg(classes, classes_v), \'|\',
                    showreg(server, server_v), \'|\', showreg(section, section_v), \'|\',
                    showreg(teststep, teststep_v)) as dcsst, \'\' as mastergrp
           from gautolimits
           where groupID = @groupid
         union all
         select \'L\' as lt, gautolimits.ID, \'limit\' as n, bemerkungen as rem, locate(\'\\n\', bemerkungen) as nl,
             concat(showreg(domain, domain_v), \'|\', showreg(classes, classes_v), \'|\',
                    showreg(server, server_v), \'|\', showreg(section, section_v), \'|\',
                    showreg(teststep, teststep_v)) as dcsst, concat(\':\', gruppen.name) as mastergrp
           from gautolimits
           join masterslavegroups
             on masterslavegroups.mastergroupID = gautolimits.groupID
               and masterslavegroups.slavegroupID = @groupid
           join gruppen on gruppen.ID = masterslavegroups.mastergroupID
         union all
         select \'I\' as lt, ID, \'isalive\' as n, bemerkungen as rem, locate(\'\\n\', bemerkungen) as nl,
             concat(showreg(domain, domain_v), \'|\', showreg(classes, classes_v), \'|\',
                    showreg(server, server_v), \'|\', showreg(section, section_v), \'|\',
                    showreg(teststep, teststep_v)) as dcsst, \'\' as mastergrp
           from gautoisalive
           where groupID = @groupid
         union all
         select \'I\' as lt, gautoisalive.ID, \'isalive\' as n, bemerkungen as rem, locate(\'\\n\', bemerkungen) as nl,
             concat(showreg(domain, domain_v), \'|\', showreg(classes, classes_v), \'|\',
                    showreg(server, server_v), \'|\', showreg(section, section_v), \'|\',
                    showreg(teststep, teststep_v)) as dcsst, concat(\':\', gruppen.name) as mastergrp
           from gautoisalive
           join masterslavegroups
             on masterslavegroups.mastergroupID = gautoisalive.groupID
               and masterslavegroups.slavegroupID = @groupid
           join gruppen on gruppen.ID = masterslavegroups.mastergroupID
         union all
         select \'C\' as lt, ID, \'combilimit\' as n, bemerkungen as rem, locate(\'\\n\', bemerkungen) as nl,
             concat(showreg(domain, domain_v), \'|\', showreg(classes, classes_v), \'|\',
                    showreg(server, server_v), \'|\', showreg(section, section_v), \'|\',
                    showreg(teststep, teststep_v)) as dcsst, \'\' as mastergrp
           from gautocombilimits
           where groupID = @groupid
         union all
         select \'C\' as lt, gautocombilimits.ID, \'combilimit\' as n, bemerkungen as rem, locate(\'\\n\', bemerkungen) as nl,
             concat(showreg(domain, domain_v), \'|\', showreg(classes, classes_v), \'|\',
                    showreg(server, server_v), \'|\', showreg(section, section_v), \'|\',
                    showreg(teststep, teststep_v)) as dcsst, concat(\':\', gruppen.name) as mastergrp
           from gautocombilimits
           join masterslavegroups
             on masterslavegroups.mastergroupID = gautocombilimits.groupID
               and masterslavegroups.slavegroupID = @groupid
           join gruppen on gruppen.ID = masterslavegroups.mastergroupID
         union all
         select \'M\' as lt, gruppen.ID, \'template:\' as n, description as rem, 0 as nl,
            \'all template limits\' as dcsst, gruppen.name as mastergrp
         from gruppen
         join masterslavegroups
           on masterslavegroups.mastergroupID = gruppen.ID and masterslavegroups.slavegroupID = @groupid
         order by find_in_set(lt, \'L,I,C,M\'), mastergrp, rem) as limits';
end//
