-- prepgrpdeststmtnossc.sql
--
-- procedure prepgrpdeststmtnossc()
-- string für %option Elemente der Gruppe @groupid vorbereiten
-- zur Anzeige der Meldungsziele einer Gruppe ohne Ziele mit "send status change"
-- wenn @showid gesetzt ist, wird das Element mit der ID @showid
-- angezeigt, auch wenn keine Rechte mehr bestehen
--
-- Aufruf als:
--   %mysqlwrite("call prepgrpdeststmtnossc()")
--   %option z%mysqlvalue(0) " " %mysqlread("execute vmz"), %mysqlvalue(3);

set @@character_set_client = 'utf8';

delimiter //

DROP PROCEDURE IF EXISTS prepgrpdeststmtnossc//
create procedure prepgrpdeststmtnossc()
deterministic
sql security invoker
begin
  prepare vmz from '
     select concat(meldungsziele.ID, \':"\', meldungszielarten.name, \':\', kurzname,
                   \'":"\', replace(replace(ziel, \',\', \', \'), \'"\', \'&quot;\'), \'"\') as oc
     from meldungsziele
     join meldungszielarten
       on meldungszielarten.ID = meldungszielartenID and NOT find_in_set(\'sendstatuschange\', meldungszielarten.flags)
     left join gruppenmeldziele as gm
       on gm.meldzielID=meldungsziele.ID
         and gm.gruppenID = @groupid
     left join utttarget
       on utttarget.groupID = @groupid and utttarget.ID = meldungsziele.ID
         and utttarget.disabled = \'0\'
     where gm.meldzielID is not null or utttarget.ID is not null
            or meldungsziele.ID = @showid
     group by meldungsziele.ID
     order by meldungszielarten.name, kurzname';
end//
