-- preplimgrpdeststmt.sql
--
-- procedure preplimgrpdeststmt()
-- string für %option Elemente der Gruppe @groupid vorbereiten
-- zur Anzeige der Meldungsziele einer Gruppe ohne UTT Ziele
-- wenn @showid gesetzt ist, wird das Element mit der ID @showid
-- angezeigt, auch wenn keine Rechte mehr bestehen
--
-- Aufruf als:
--   %mysqlwrite("call preplimgrpdeststmt()")
--   %option z%mysqlvalue(0) " " %mysqlread("execute vmz"), %mysqlvalue(3);


set @@character_set_client = 'utf8';

delimiter //

DROP PROCEDURE IF EXISTS preplimgrpdeststmt//
create procedure preplimgrpdeststmt()
deterministic
sql security invoker
begin
  prepare vmz from '
     select concat(meldungsziele.ID, \':"\', meldungszielarten.name, \':\', kurzname,
                   \'":"\', replace(replace(ziel, \',\', \', \'), \'"\', \'&quot;\'), \'"\') as oc
     from meldungsziele
     join meldungszielarten on meldungszielarten.ID = meldungszielartenID
     left join gruppenmeldziele as gm
       on gm.meldzielID = meldungsziele.ID and gm.gruppenID = @groupid
     where gm.meldzielID is not null or meldungsziele.ID = @showid
     group by meldungsziele.ID
     order by meldungszielarten.name, kurzname';
end//
