set @@character_set_client = 'utf8';

delimiter //

DROP PROCEDURE IF EXISTS prepvmeldzielstmt//
create procedure prepvmeldzielstmt()
deterministic
sql security invoker
begin
  prepare vmz from '
     select concat(mz.ID, \':"\', ma.name, \':\', kurzname,
                   if(mz.meldungszielartenID, \'\', concat(\' (\', g.name, \')\')),
                   \'":"\', replace(replace(ziel,\'"\',\'&quot;\'), \',\', \', \'),\'"\') as oc
     from meldungsziele as mz
     join meldungszielarten as ma on ma.ID = mz.meldungszielartenID
     left join verfahrenmeldziele as vm
       on vm.meldzielID = mz.ID and vm.verfahrenID = @domid
         and mz.meldungszielartenID > 0
     left join gruppenrechte as gr
       on gr.verfahrenID = @domid and gr.accessID = @accid
     left join gruppenmeldziele as gm
       on gm.meldzielID = mz.ID and gm.gruppenID = gr.gruppenID
         and mz.meldungszielartenID > 0
     left join utttarget as ut
       on ut.ID = mz.ID and ut.groupID = gr.gruppenID
     left join gruppen as g
       on g.ID = ut.groupID
     where (mz.meldungszielartenID > 0 OR ut.ID is not null)
       and (gm.meldzielID is not null or vm.meldzielID is not null
            or (ut.ID is not null and ut.disabled = \'0\') or mz.ID = @showid)
     group by mz.ID
     order by ma.name, kurzname';
end//

GRANT EXECUTE on PROCEDURE prepvmeldzielstmt to logginglesen@'localhost'//
