-- prevof.sql
--
-- function prevof(wid) returns varchar
-- wid: werteindizesID
-- return: first value of the last 2 values with werteindizesID == "wid"

-- combined details
-- combined limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS prevof//
create function prevof(wid integer) returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID = wid and teststepdetailsID = teststepdetails.ID
        and einheitID = einheiten.ID;
    case wt
      when 'swerte' then return prevofs(wid);
      when 'twerte' then return prevoft(wid);
      when 'cwerte' then return prevofc(wid);
      when 'pwerte' then return prevofp(wid);
      else               return prevofz(wid);
    end case;
  end//
