-- prevofb.sql
--
-- function prevofb(wid, todt) returns varchar
-- wid: werteindizesID
-- todt: up to datetime
-- return: first value of the last 2 values before "todt" with werteindizesID == "wid"

-- combined details
-- combined limits

set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS prevofb//
create function prevofb(wid integer, todt datetime(6)) returns varchar(20000)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab into wt from werteindizes, teststepdetails, einheiten
      where werteindizes.ID = wid and teststepdetailsID = teststepdetails.ID
        and einheitID = einheiten.ID;
    case wt
      when 'swerte' then return prevofsb(wid, todt);
      when 'twerte' then return prevoftb(wid, todt);
      when 'cwerte' then return prevofcb(wid, todt);
      when 'pwerte' then return prevofpb(wid, todt);
      else               return prevofzb(wid, todt);
    end case;
  end//
