-- quoteulswildcard.sql
--
-- function quoteulswildcard(s) returns varchar
-- s: string to quote
-- return: quoted string s
--
-- Quoting von Sonderzeichen bei ULS-Wildcards
-- Zeichen: ?  *  , {  }  \
--          und ! am Anfang

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS quoteulswildcard//
create function quoteulswildcard(s varchar(500)) returns varchar(600)
  deterministic
  sql security invoker
  begin
    declare i integer;
    declare p, r varchar(600);

    set i = regexp_instr(s, '[?*,{}\\\\]');
    if i > 0 then
      set r = concat(left(s, i-1), '\\', substr(s, i, 1));
      set p = substr(s, i+1);
      set i = regexp_instr(p, '[?*,{}\\\\]');
      while i > 0 do
        set r = concat(r, left(p, i-1), '\\', substr(p, i, 1));
        set p = substr(p, i+1);
        set i = regexp_instr(p, '[?*,{}\\\\]');
      end while;
      if r like '!%' then
        return concat('\\', r, p);
      else
        return concat(r, p);
      end if;
    elseif s like '!%' then
      return concat('\\', s);
    else
      return s;
    end if;

  end//
