-- regpos.sql
--
-- functino regpos(elem, reg) returns integer
-- elem: element to search for
-- reg: regular expression
-- return: position from elem in reg (elements separated by |)
--         on not found number of elements in reg + 1

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS regpos//
create function regpos(elem varchar(330), reg varchar(2000)) returns integer
  deterministic
  sql security invoker
  begin
    declare i, p integer;
    declare r, treg varchar(2000);

    set i = 1;
    set treg = reg;
    while treg != ''
     do
      set p = instr(treg, '|');
      if p = 0
       then
        set r = treg;
        set treg = '';
      else
        set r = left(treg, p-1);
        set treg = substring(treg, p+1);
      end if;
      if r != ''
       then
        if elem regexp r then
          return i;
        end if;
      end if;
      set i = i + 1;
    end while;
    return i;
  end//
