-- replacedate.sql
--
-- function replacedate(s) returns mediumtext
-- s: report name or description
-- return: update $DATE(<format>) in report names or descriptions

-- $DATE(format) ersetzen durch aktuelles formatiertes Datum

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS replacedate//
create function replacedate(s mediumtext) returns mediumtext
  deterministic
  sql security invoker
  begin
    declare i, j integer;
    declare ret mediumtext;

    set ret = s;
    set i = locate('$DATE(', ret);
    while i > 0 do
      set j = locate(')', ret, i);
      if j > 0 then
        set ret = concat(left(ret, i-1), date_format(now(), substr(ret, i+6, j-i-6)), substr(ret, j+1));
      else
        set ret = left(ret, i-1);
      end if;
      set i = locate('$DATE(', ret);
    end while;
    return ret;

  end//

GRANT EXECUTE on FUNCTION replacedate to logginglesen@'localhost'//
