-- reset_server_limits.sql
--
-- procedure reset_server_limits(srvid)
-- srvid: serverID
--
-- reset all server-limits after reactivating a server

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS reset_server_limits//
create
  definer = 'loggingtest'@'localhost'
  procedure reset_server_limits(srvid integer unsigned)
  deterministic
  sql security definer
 begin

  update twertelimits
    join wertelimits on wertelimits.ID = twertelimits.ID
    join werteindizes
      on werteindizes.ID = wertelimits.werteindizesID and werteindizes.serverID = srvid
    set lasttestdate = now();

  update tlwertelimits
    join lwertelimits on lwertelimits.ID = tlwertelimits.ID
    join lwerteindizes
      on lwerteindizes.ID = lwertelimits.lwerteindizesID and lwerteindizes.serverID = srvid
    set lasttestdate = now();

end//

GRANT EXECUTE on PROCEDURE reset_server_limits to 'loggingadmin'@'localhost'//
GRANT EXECUTE on PROCEDURE reset_server_limits to 'loggingtest'@'localhost'//
