-- serverdocu_remark.sql
--
-- function serverdocu_remark(srvs, sdname) returns varchar
-- srvs: servers as ULS-wildcard
-- sdname: name of serverdocu
-- return: concat of all found descriptions
-- temporary table loggingtmp.xwids must exists, do_report

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS serverdocu_remark//
create function serverdocu_remark(srvs varchar(4000), sdname varchar(200)) returns varchar(21844)
  deterministic
  sql security invoker
  begin
    declare rxs, rxsv varchar(2000);

    call genreg(trim(srvs), rxs, rxsv);
    return (select group_concat(beschreibung separator '\n')
            from serverdoku
            where name = trim(sdname)
              and exists (select *
                          from loggingtmp.xwids
                          join server on server.ID = xwids.s and testreg(servername, rxs, rxsv)
                          where xwids.s = serverdoku.serverID));
end //
