-- sround.sql
--
-- function sround(v, s) returns varchar
-- v: value
-- s: numbers
-- return: v rounded to s numbers

-- Zahl runden auf s signifikante Ziffern, allerdings nur nach dem Komma

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS sround//
create function sround(v varchar(30), s int) returns varchar(30)
  deterministic
  sql security invoker
  begin
    declare i integer;

    if v = 0 then
      set i = s;
    else
      set i = s - 1 - floor(log10(abs(v)));
      if i < 0 then
        set i = 0;
      end if;
    end if;
    return cast(round(v, i) as char(30));
  end//

GRANT EXECUTE on FUNCTION sround to logginglesen@'localhost', loggingtest@'localhost'//
