-- storebwerte.sql
--
-- procedure storebwerte(b, bid bigint)
-- b: data
-- bid: ID in bwerte
--
-- find data in daten or insert into daten and update datenID in bwerte ID = bid
-- 

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS storebwerte//
create procedure storebwerte(b longblob, bid bigint unsigned)
  deterministic
  sql security invoker
 begin

  declare b5 varchar(32);
  declare nd bigint unsigned;

  set b5 = md5(b);

  set nd = (select ID from daten where md5sum = b5 and daten = b order by ID limit 1);
  if nd is NULL then
    insert into daten set md5sum = b5, daten = b;
    set nd = last_insert_id();
  end if;

  update bwerte set datenID = nd where ID = bid;

end//
