-- storebwertewid.sql
--
-- procedure storebwertewid(b, bid bigint, wid int)
-- b: data
-- bid: ID from bwerte
-- wid: werteindizesID
--
-- find deduplicatet binary data b or insert b into daten and set
-- datenID in bwerte with ID = bid

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS storebwertewid//
create procedure storebwertewid(b longblob, bid bigint unsigned, wid int unsigned)
  deterministic
  sql security invoker
 begin

  declare b5 varchar(32);
  declare nd bigint unsigned;

  set b5 = md5(b);

  set nd = (select ID from daten where md5sum = b5 and daten = b order by ID limit 1);
  if nd is NULL then
    insert into daten set md5sum = b5, daten = b;
    set nd = last_insert_id();
  end if;

  update bwerte set datenID = nd, werteindizesID = wid where ID = bid;

end//

GRANT INSERT, UPDATE (datenID, werteindizesID) ON `logging`.`bwerte` TO 'logging'@'localhost'//
