-- storewert.sql
--
-- procedure storewert(srvid, nsec, ntst, ndet, neh, nacc, dt, w)
-- srvid: serverID
-- nsec: section
-- ntst: teststep
-- ndet: detail
-- neh: unit
-- nacc: access
-- dt: datetime
-- w: value
--
-- Store ULS-Value


set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS storewert//
create
  definer = 'logging'@'localhost'
  procedure storewert(srvid integer unsigned, nsec varchar(50), ntst varchar(200),
                           ndet varchar(100), neh varchar(100), nacc varchar(20),
                           dt datetime(6), w varchar(20000))
  deterministic
  sql security definer
 begin
  declare wid, sec, tst, det, eh, aid integer;
  declare wt varchar(30);

  call newsec(nsec, sec);
  call newtst(ntst, tst);
  call neweh(neh, eh);
  select wtab into wt from einheiten where ID=eh;
  call newdet(ndet, eh, det);
  select getacc(nacc) into aid;
  call newwid(srvid, sec, tst, det, aid, wid);

  update letztewerte set lastwert = w, lastdatum = dt
    where ID = wid and dt >= lastdatum;

  case wt
    when 'swerte' then insert into swerte set werteindizesID = wid, wert = w, datum = dt;
    when 'twerte' then insert into twerte set werteindizesID = wid, wert = w, datum = dt;
    when 'pwerte' then insert into pwerte set werteindizesID = wid, wert = w, datum = dt;
    when 'cwerte' then insert into cwerte set werteindizesID = wid, wert = w, datum = dt;
    else               insert into zwerte set werteindizesID = wid, wert = w, datum = dt;
  end case;

  call wzeiten(wid, srvid, sec, tst, det, aid, date(dt));

end//

GRANT EXECUTE on PROCEDURE storewert to logging@'localhost', loggingadmin@'localhost',
  logginglesen@'localhost', loggingtest@'localhost'//
