-- testallfromto.sql
--
-- procedure testallfromto(wid, fromdt, relation, infov, warnv, errorv, OUT e, OUT lw)
-- wid: werteindizesID
-- fromdt: datetime from
-- relation: relation for compare
-- infov: info limit
-- warnv: warn limit
-- errorv: error limit
-- e: errorlevel - '', 'INFO', 'WARN', 'ERROR'
-- lw: last value

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS testallfrom//
create procedure testallfrom(wid integer, fromdt datetime, relation varchar(15),
                             infov varchar(2000), warnv varchar(2000), errorv varchar(2000),
                             OUT e varchar(10), OUT lw varchar(20000))
deterministic
sql security invoker
begin
  declare wt, w varchar(20);
  declare sel varchar(400);

  select wtab into wt from werteindizes, teststepdetails, einheiten
    where werteindizes.ID = wid and teststepdetailsID = teststepdetails.ID and einheitID = einheiten.ID;

  if relation regexp '==|~' OR find_in_set(wt, 'swerte,twerte') then
    if relation like '%|' then
      set w = 'wert ';
      set relation = replace(relation, '|', '');
    else
      set w = 'binary wert ';
    end if;
  else
    if relation like '%|' then
      set w = 'abs(0+wert) ';
      set relation = replace(relation, '|', '');
    else
      set w = '0+wert ';
    end if;
  end if;

  if relation = '==' then
    set relation = '=';
  elseif relation = '!==' then
    set relation = '!=';
  elseif relation = '~' then
    set relation = 'regexp';
  elseif relation = '!~' then
    set relation = 'not regexp';
  elseif relation = '~~' then
    set relation = 'like';
  elseif relation = '!~~' then
    set relation = 'not like';
  end if;

  if relation = 'like' OR relation = 'not like' then
    set sel = concat('select count(*), sum(? != \'\' and ', w, relation, ' concat(\'%\', ?, \'%\')), sum(? != \'\' and ', w, relation,
      ' concat(\'%\', ?, \'%\')), sum(? != \'\' and ', w, relation,
      ' concat(\'%\', ?, \'%\')) into @cntall, @cntinfo, @cntwarn, @cnterror from ', wt,
      ' where werteindizesID = ? and ? <= datum group by werteindizesID');
  else
    set sel = concat('select count(*), sum(? != \'\' and ', w, relation, ' ?), sum(? != \'\' and ', w, relation, ' ?), sum(? != \'\' and ', w, relation,
      ' ?) into @cntall, @cntinfo, @cntwarn, @cnterror from ', wt,
      ' where werteindizesID = ? and ? <= datum group by werteindizesID');
  end if;

  set @cntall = 0;

  prepare prepsel from sel;
  execute prepsel using infov, infov, warnv, warnv, errorv, errorv, wid, fromdt;
  drop prepare prepsel;

  if @cntall = 0 then
    set e = '';
  elseif errorv != '' AND @cntall = @cnterror then
    set e = 'ERROR';
  elseif warnv != '' AND @cntall = @cntwarn then
    set e = 'WARN';
  elseif infov != '' AND @cntall = @cntinfo then
    set e = 'INFO';
  else
    set e = '';
  end if;
  if e = '' then
    set lw = '';
  else
    set lw = (select lastwert from letztewerte where ID = wid);
  end if;
end//
