-- testallfrome.sql
--
-- procedure testallfrome(wid, fromdt, todt, relation, infov, warnv, errorv, OUT e, OUT lw)
-- wid: werteindizesID
-- fromdt: datetime from
-- todt: datetime to
-- relation: relation for compare
-- infov: info limit
-- warnv: warn limit
-- errorv: error limit
-- e: errorlevel - '', 'INFO', 'WARN', 'ERROR'
-- lw: last value

set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS testallfrome//
create procedure testallfrome(wid integer, fromdt datetime, relation varchar(15),
                             infov varchar(2000), warnv varchar(2000), errorv varchar(2000),
                             OUT e varchar(10), OUT lw varchar(20000))
deterministic
sql security invoker
begin
  declare unit, w varchar(50);
  declare sel varchar(400);

  set lw = (select lastwert from letztewerte where ID = wid);

  if relation = '==' then
    set w = 'binary wert';
    set relation = '=';
  elseif relation = '==|' then
    set w = 'wert';
    set relation = '=';
  elseif relation = '~' then
    set w = 'binary wert';
    set relation = 'regexp';
  elseif relation = '~|' then
    set w = 'wert';
    set relation = 'regexp';
  elseif relation = '!~' then
    set w = 'binary wert';
    set relation = 'not regexp';
  elseif relation = '!~|' then
    set w = 'wert';
    set relation = 'not regexp';
  elseif relation = '~~' then
    set w = 'binary wert';
    set relation = 'like';
  elseif relation = '~~|' then
    set w = 'wert';
    set relation = 'like';
  elseif relation = '!~~' then
    set w = 'binary wert';
    set relation = 'not like';
  elseif relation = '!~~|' then
    set w = 'wert';
    set relation = 'not like';
  else
    set unit = substring_index(lw, ' ', -1);
    if relation like '%|' then
      set w = concat('abs(0+ehwconv(wert, \'', unit, '\'))');
      set relation = replace(relation, '|', '');
    else
      set w = concat('0+ehwconv(wert, \'', unit, '\')');
    end if;
    set infov = ehwconv(infov, unit);
    set warnv = ehwconv(warnv, unit);
    set errorv = ehwconv(errorv, unit);
  end if;

  if relation = 'like' OR relation = 'not like' then
    set sel = concat('select count(*), sum(? != \'\' and ', w, relation, ' concat(\'%\', ?, \'%\')), sum(? != \'\' and ', w, relation,
      ' concat(\'%\', ?, \'%\')), sum(? != \'\' and ', w, relation,
      ' concat(\'%\', ?, \'%\')) into @cntall, @cntinfo, @cntwarn, @cnterror from twerte where werteindizesID = ? and ? <= datum group by werteindizesID');
  else
    set sel = concat('select count(*), sum(? != \'\' and ', w, relation, ' ?), sum(? != \'\' and ', w, relation, ' ?), sum(? != \'\' and ', w, relation,
      ' ?) into @cntall, @cntinfo, @cntwarn, @cnterror from twerte where werteindizesID = ? and ? <= datum group by werteindizesID');
  end if;

  set @cntall = 0;

  prepare prepsel from sel;
  execute prepsel using infov, infov, warnv, warnv, errorv, errorv, wid, fromdt;
  drop prepare prepsel;

  if @cntall = 0 then
    set e = '';
  elseif errorv != '' AND @cntall = @cnterror then
    set e = 'ERROR';
  elseif warnv != '' AND @cntall = @cntwarn then
    set e = 'WARN';
  elseif infov != '' AND @cntall = @cntinfo then
    set e = 'INFO';
  else
    set e = '';
  end if;
  if e = '' then
    set lw = '';
  end if;
end//
