-- testreg.sql
--
--  function testreg(r, ri, re) returns boolean
--  r: expression to compare
--  ri: regexp include
--  re: regexp not include
--  return: r REGEXP ri and r NOT REGEXP re
--
--  compare r with ri and not re

set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS testreg//
create function testreg(r varchar(2000), ri varchar(2000), re varchar(2000)) returns boolean
  deterministic
  sql security invoker
  begin
    if re = ''
     then
      return r REGEXP ri;
    else
      return r REGEXP ri and r NOT REGEXP re;
    end if;
  end//

GRANT EXECUTE on FUNCTION testreg to logging@'localhost', logginglesen@'localhost',
  loggingadmin@'localhost', loggingtest@'localhost'//
