-- uvaccess.sql
--
-- view uvaccess
-- columns userID, verfahrenID, accessID
-- access list (acces from user and group rights)
--
-- view uvaccessa
-- columns userID, verfahrenID, accessID
-- access list with admin right (acces from user and group rights)
--
-- view uvaccessadmin
-- columns userID, verfahrenID, accessID, admin
-- access list (acces from user and group rights)
--
-- view uvaccessm
-- columns userID, verfahrenID, accessID, max(admin) as admin
-- access list (acces from user and group rights)

set @@character_set_client = 'utf8';

CREATE OR REPLACE sql security invoker VIEW uvaccess (userID, verfahrenID, accessID)
  AS
    select userID, verfahrenID, accessID
    from userrechte
    union distinct
    select distinct userID, verfahrenID, accessID
    from usergruppen, gruppenrechte
    where usergruppen.gruppenID = gruppenrechte.gruppenID;

CREATE OR REPLACE sql security invoker VIEW uvaccessa (userID, verfahrenID, accessID)
  AS
    select userID, verfahrenID, accessID
    from userrechte where admin = '1'
  union distinct
    select distinct userID, verfahrenID, accessID
    from usergruppen
    join user on user.ID = usergruppen.userID and not find_in_set(rights, 'service')
    join gruppenrechte on gruppenrechte.gruppenID = usergruppen.gruppenID and admin = '1';

CREATE OR REPLACE sql security invoker VIEW uvaccessadmin (userID, verfahrenID, accessID, admin)
  AS
    select userID, verfahrenID, accessID, admin
    from userrechte
  union distinct
    select distinct userID, verfahrenID, accessID, if(find_in_set(rights, 'service'), 0, admin) as admin
    from usergruppen
    join user on user.ID = userID
    join gruppenrechte on gruppenrechte.gruppenID = usergruppen.gruppenID
    where accessID = 1 OR not find_in_set(rights, 'service');

CREATE OR REPLACE sql security invoker VIEW uvaccessm (userID, verfahrenID, accessID, admin)
  as
    select userID, verfahrenID, accessID, max(admin) as admin
    from uvaccessadmin
    group by userID, verfahrenID, accessID;
