set @@character_set_client = 'utf8';

CREATE TABLE `cclimits` (
  `ID` int unsigned NOT NULL AUTO_INCREMENT,
  `serverID` int unsigned NOT NULL DEFAULT 0,
  `sectionID` int unsigned NOT NULL,
  `teststepID` int unsigned NOT NULL,
  `usedwIDs` varchar(500) NOT NULL DEFAULT '',
  `expression` varchar(1000) NOT NULL DEFAULT '',
  `expressionsql` varchar(2000) NOT NULL DEFAULT '',
  `infolevel` varchar(1000) NOT NULL,
  `warnlevel` varchar(1000) NOT NULL,
  `errorlevel` varchar(1000) NOT NULL,
  `notifymode` enum('24','O') NOT NULL DEFAULT '24',
  `relation` varchar(10) NOT NULL DEFAULT '',
  `meldung` varchar(3000) NOT NULL DEFAULT '',
  `meldungszielID` int(10) unsigned NOT NULL DEFAULT 0,
  `dest1level` set('INFO','WARN','ERROR') NOT NULL DEFAULT 'INFO,WARN,ERROR',
  `meldungsziel2ID` int(10) unsigned NOT NULL DEFAULT 0,
  `dest2level` set('INFO','WARN','ERROR') NOT NULL DEFAULT 'INFO,WARN,ERROR',
  `aktiv` tinyint(1) NOT NULL DEFAULT '1',
  `hidden` tinyint(1) NOT NULL DEFAULT 0,
  `domautoID` int unsigned NOT NULL DEFAULT 0,
  `groupautoID` int unsigned NOT NULL DEFAULT 0,
  `slavegroupID` int unsigned DEFAULT NULL,
  `bemerkungen` varchar(5000) NOT NULL DEFAULT '',
  `accessID` int unsigned NOT NULL DEFAULT 1,
  `override` set('expression','relation','infolevel','warnlevel','errorlevel','notifymode','message','dest1ID','dest1level','dest2ID','dest2level','remark') NOT NULL DEFAULT '',
  `TS` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`ID`),
  KEY `groupautoID` (`groupautoID`),
  KEY `domautoID` (`domautoID`),
  KEY `sst` (`serverID`,`sectionID`,`teststepID`,`accessID`)
);

CREATE TABLE `tcclimits` (
  `ID` int(10) unsigned NOT NULL DEFAULT 0,
  `lasttestdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `msgdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `msglevel` enum('none','info','warn','error','unknown') NOT NULL DEFAULT 'unknown',
  `lastlevel` tinyint NOT NULL DEFAULT 0,
  `uttclosed` tinyint(1) NOT NULL DEFAULT 0,
  `alarmvalue` varchar(300) NOT NULL DEFAULT '',
  `alarmtimestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`ID`)
);

CREATE TABLE `autocclimits` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `verfahrenID` int unsigned NOT NULL DEFAULT 0,
  `classes` varchar(200) NOT NULL DEFAULT '.*',
  `classes_v` varchar(100) NOT NULL DEFAULT '',
  `server` varchar(500) NOT NULL DEFAULT '',
  `server_v` varchar(300) NOT NULL DEFAULT '',
  `section` varchar(500) NOT NULL DEFAULT '',
  `section_v` varchar(300) NOT NULL DEFAULT '',
  `teststep` varchar(500) NOT NULL DEFAULT '',
  `teststep_v` varchar(300) NOT NULL DEFAULT '',
  `regexpflag` tinyint(1) NOT NULL DEFAULT '0',
  `details` varchar(1000) NOT NULL DEFAULT '',
  `expression` varchar(1000) NOT NULL DEFAULT '',
  `infolevel` varchar(1000) NOT NULL,
  `warnlevel` varchar(1000) NOT NULL,
  `errorlevel` varchar(1000) NOT NULL,
  `notifymode` enum('24','O') NOT NULL DEFAULT '24',
  `relation` varchar(10) NOT NULL DEFAULT '',
  `meldung` varchar(3000) NOT NULL DEFAULT '',
  `meldungszielID` int unsigned NOT NULL DEFAULT 0,
  `dest1level` set('INFO','WARN','ERROR') NOT NULL DEFAULT 'INFO,WARN,ERROR',
  `meldungsziel2ID` int unsigned NOT NULL DEFAULT 0,
  `dest2level` set('INFO','WARN','ERROR') NOT NULL DEFAULT 'INFO,WARN,ERROR',
  `aktiv` tinyint(1) NOT NULL DEFAULT '1',
  `bemerkungen` varchar(5000) NOT NULL DEFAULT '',
  `accessID` int unsigned NOT NULL DEFAULT 1,
  `TS` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`ID`),
  KEY `verfahrenID` (`verfahrenID`)
);

CREATE TABLE `gautocclimits` (
  `ID` int unsigned NOT NULL AUTO_INCREMENT,
  `groupID` int unsigned NOT NULL DEFAULT 0,
  `domain` varchar(500) NOT NULL DEFAULT '',
  `domain_v` varchar(300) NOT NULL DEFAULT '',
  `classes` varchar(200) NOT NULL DEFAULT '.*',
  `classes_v` varchar(100) NOT NULL DEFAULT '',
  `server` varchar(500) NOT NULL DEFAULT '',
  `server_v` varchar(300) NOT NULL DEFAULT '',
  `section` varchar(500) NOT NULL DEFAULT '',
  `section_v` varchar(300) NOT NULL DEFAULT '',
  `teststep` varchar(500) NOT NULL DEFAULT '',
  `teststep_v` varchar(300) NOT NULL DEFAULT '',
  `regexpflag` tinyint(1) NOT NULL DEFAULT '0',
  `nootherflag` tinyint(1) NOT NULL DEFAULT 0,
  `overridemaster` tinyint(1) NOT NULL DEFAULT 0,
  `details` varchar(1000) NOT NULL DEFAULT '',
  `expression` varchar(1000) NOT NULL DEFAULT '',
  `infolevel` varchar(1000) NOT NULL,
  `warnlevel` varchar(1000) NOT NULL,
  `errorlevel` varchar(1000) NOT NULL,
  `notifymode` enum('24','O') NOT NULL DEFAULT '24',
  `relation` varchar(10) NOT NULL DEFAULT '',
  `meldung` varchar(3000) NOT NULL DEFAULT '',
  `meldungszielID` int unsigned NOT NULL DEFAULT 0,
  `dest1level` set('INFO','WARN','ERROR') NOT NULL DEFAULT 'INFO,WARN,ERROR',
  `meldungsziel2ID` int(10) unsigned NOT NULL DEFAULT 0,
  `dest2level` set('INFO','WARN','ERROR') NOT NULL DEFAULT 'INFO,WARN,ERROR',
  `aktiv` tinyint(1) NOT NULL DEFAULT '1',
  `bemerkungen` varchar(5000) NOT NULL DEFAULT '',
  `accessID` int unsigned NOT NULL DEFAULT 1,
  `TS` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`ID`),
  KEY `verfahrenID` (`groupID`)
);

alter table `changeprot`
  modify `changedtable` enum('wertelimits','autolimits','gautolimits','kombilimits','autokombilimits','gautocombilimits',
      'isalive','autoisalive','gautoisalive','lwertelimits','autollimits','gautoclimits','ueberwachungspausen','clientsuspensions',
      'kombidetails','autokombidetails','gautocombidetails','ccdetails','autoccdetails','gautoccdetails','lwerteindizes',
      'autokomprimierung','gautocompression','werteindizes','autoaufbewahrung','gautorettime','kautoaufbewahrung','gautocrettime',
      'mailreports','mailreportsended','limitgroup','limitgroupelement','limitgroupnotify','cclimits','autocclimits','gautocclimits') NOT NULL DEFAULT 'werteindizes';

alter table `uttevent`
  modify `limittype` enum('limits','isAlive','combilimits','compressedlimits','aggregationlimits','aggregationcombilimits') NOT NULL DEFAULT 'limits';

GRANT SELECT, INSERT, UPDATE, DELETE ON `logging`.`cclimits` TO 'logginglesen'@'localhost';
GRANT UPDATE(lastlevel, msglevel) ON `logging`.`tcclimits` TO 'logginglesen'@'localhost';
GRANT SELECT, INSERT, UPDATE, DELETE ON `logging`.`autocclimits` TO 'logginglesen'@'localhost';
GRANT SELECT, INSERT, UPDATE, DELETE ON `logging`.`gautocclimits` TO 'logginglesen'@'localhost';

GRANT execute ON `logging`.* TO 'loggingtest'@'localhost';
GRANT select ON `logging`.cclimits TO 'loggingtest'@'localhost';
GRANT select ON `logging`.autocclimits TO 'loggingtest'@'localhost';
GRANT select ON `logging`.gautocclimits TO 'loggingtest'@'localhost';
GRANT select, update ON `logging`.tcclimits TO 'loggingtest'@'localhost';
