set @@character_set_client = 'utf8';

CREATE TABLE `groupsuspensions` (
  `ID` int unsigned NOT NULL AUTO_INCREMENT,
  `nextdayID` int unsigned NOT NULL DEFAULT 0,
  `groupID` int unsigned NOT NULL DEFAULT 0,
  `domain` varchar(500) NOT NULL DEFAULT '',
  `domain_v` varchar(300) NOT NULL DEFAULT '',
  `server` varchar(500) NOT NULL DEFAULT '',
  `server_v` varchar(300) NOT NULL DEFAULT '',
  `classes` varchar(200) NOT NULL DEFAULT '.*',
  `classes_v` varchar(100) NOT NULL DEFAULT '',
  `section` varchar(500) NOT NULL DEFAULT '',
  `section_v` varchar(300) NOT NULL DEFAULT '',
  `teststep` varchar(500) NOT NULL DEFAULT '',
  `teststep_v` varchar(300) NOT NULL DEFAULT '',
  `details` varchar(500) NOT NULL DEFAULT '',
  `details_v` varchar(300) NOT NULL DEFAULT '',
  `einheit` varchar(200) NOT NULL DEFAULT '',
  `einheit_v` varchar(100) NOT NULL DEFAULT '',
  `regexpflag` tinyint unsigned NOT NULL DEFAULT 0,
  `datefrom` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `dateto` datetime NOT NULL DEFAULT '9999-12-31 23:59:59',
  `weekdays` set('0','1','2','3','4','5','6') NOT NULL DEFAULT '0,1,2,3,4,5,6',
  `timefrom` time NOT NULL DEFAULT '00:00:00',
  `timeto` time NOT NULL DEFAULT '23:59:59',
  `mdays` varchar(90) NOT NULL DEFAULT '',
  `hidesuspended` tinyint unsigned NOT NULL DEFAULT 0,
  `remark` varchar(255) NOT NULL,
  `accessID` int(10) unsigned NOT NULL DEFAULT 1,
  `TS` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`ID`),
  KEY `dateto` (`dateto`,`datefrom`),
  KEY `groupID` (`groupID`),
  KEY `nextdayID` (`nextdayID`)
);

alter table changeprot
  modify `changedtable` enum('wertelimits','autolimits','gautolimits','kombilimits','autokombilimits','gautocombilimits','isalive','autoisalive','gautoisalive','lwertelimits','autollimits','gautoclimits','ueberwachungspausen','clientsuspensions','kombidetails','autokombidetails','gautocombidetails','ccdetails','autoccdetails','gautoccdetails','lwerteindizes','autokomprimierung','gautocompression','werteindizes','autoaufbewahrung','gautorettime','kautoaufbewahrung','gautocrettime','mailreports','mailreportsended','limitgroup','limitgroupelement','limitgroupnotify','cclimits','autocclimits','gautocclimits','groupsuspensions') NOT NULL DEFAULT 'werteindizes';

grant select on logging.groupsuspensions to 'loggingtest'@'localhost';
grant select, insert, update, delete on logging.groupsuspensions to 'logginglesen'@'localhost';
grant select, insert, update, delete on logging.groupsuspensions to 'logginglesen'@'%';
